C*****************************************
C  ***************************************
C  ***        HAUPTPROGRAMM            ***
C  ***************************************
C  ***************************************
C  DAS HAUPTPROGRAMM LIEST DIE BEFEHLE AUS DER BEFEHLS-
C  DATEI, UEBERNIMMT DIE PARAMETERWERTE UND STEUERT
C  ENTSPRECHEND DEN AUFRUF DER UNTERPROGRAMME
C**********************************************************
C*  VERWENDETE VARIABLEN:                                 *
C*                                                        *
C*  TYP    : BELEGT MIT '*TYP'. DIENT DAZU, DEN BEFEHL    *
C*           *TYPEN ZU ERKENNEN.                          *
C*  DRU    : BELEGT MIT '*DRU'. DIENT DAZU, DEN BEFEHL    *
C*           *DRUCK  ZU ERKENNEN.                         *
C*  RELE   : BEZEICHNET DIE ART DER RECHENLEISTUNG        *
C*  AUST   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN        *
C*           DER STRUKTUR STEUERT                         *
C*  AUVE   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN DER    *
C*           DER VERSCHIEBUNGEN STEUERT                   *
C*  AUSP   : LITERAL-KONSTANTE, DIE DAS AUSDRUCKEN DER    *
C*           SPANNUNGEN STEUERT                           *
C*  AULA   : LITERALKONSTANTE, DIE DAS AUSDRUCKEN DER     *
C*           AUFLAGERREAKTIONEN STEUERT                   *
C*  PLOT   : LITERALKONSTANTE, DIE DAS RETTEN DER         *
C*           VERSCHIEBUNGEN IN DIE DATEI '99' ZUM         *
C*           SPAETEREN PLOTTEN STEUERT                    *
C*  ANZA   : ANZAHL DER EINZULESENDEN ELEMENTTYPEN        *
C*  KOANZ  : DIMENSION DES KOORDINATENSYSTEMS             *
C*  FREI   : ANZAHL DER FREIHEITSGRADE PRO KNOTEN         *
C*  MBAND  : BANDBREITE DER EINGEGEBENEN STRUKTUR         *
C*  MBA    : VOM PROGRAMM ZUGELASSENE BANDBREITE          *
C*  LGS    : LAENGE DER GS-MATRIX                         *
C*                                                        *
C*  VERWENDETE FELDER                                     *
C*                                                        *
C*  A      : NIMMT EINE ZEILE AUS DER DATEI '70' AUF      *
C*  ETYP   : ENTHAELT DIE EINGELESENEN ELEMENTTYPEN       *
C*  D      : ENTHAELT SPAETER DIE FUER DAS CHOLESKY-      *
C*           VERFAHREN BENOETIGTE "DREIECKSMATRIX" AUS    *
C*           DEM BAND DER GS-MATRIX                       *
C*  LAD    : LAENGE VON D                                 *
C*  V      : ENTHAELT SPAETER DEN BELASTUNGSVEKTOR        *
C*           UND DANN DIE VERSCHIEBUNGEN                  *
C*  LAV    : LAENGE VON V                                 *
C*  XKN    : FELD DER KNOTENKOORDINATEN                   *
C*  LAX    : LAENGE VON XKN                               *
C**********************************************************
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  ANZA,FREI
      CHARACTER*4 BEF,DRU,TYP
      CHARACTER RELE,AUST,AUVE,AUSP,AULA,PLOT,NT,JA
      CHARACTER*2 NAME,NARA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /REFE/  REF(10,7)
      COMMON /RAND/  KNRA(50),RV(50,6),AUFL(50,6)
      COMMON /BELA/  KNBE(70),NULA(70),BELAST(70,6)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/  NAME(6) , NARA(50,6)
      DATA DRU,TYP,NT,JA  /'*DRU','*TYP','T','J'/
      OPEN (5,FILE='BEFST2',STATUS='OLD',ACCESS='SEQUENTIAL'
     *         ,FORM='FORMATTED')
      OPEN(UNIT=6)
      LAD = 6105
      LAX=  500
      LAV = 500
C
C             EINLESEN DES *DRUCK-BEFEHLS
C
      READ(5,1,END=140) BEF,RELE,AUST,AUVE,AUSP,AULA,PLOT
1     FORMAT(A4,2X,6(6X,A1))
      IF(BEF.EQ.DRU) GOTO 100
C
      WRITE(6,2)
2     FORMAT(1H0,'*DRUCK-BEFEHL FALSCH ODER NICHT 1. SATZ')
      STOP
C
C            EINLESEN DES *TYPEN-BEFEHLS
C
100   READ(5,3,END=140) BEF,KOANZ,FREI,ANZA,(ETYP(J),J=1,2)
     *                 ,(NAME(J),J=1,FREI)
3     FORMAT(A4,3X,3(6X,I1),6X,2F2.0,7X,6A2)
      IF (BEF.EQ.TYP) GOTO 150
C
      WRITE(6,5)
5     FORMAT(1H0,'*TYP-BEFEHL FALSCH ODER NICHT 2.SATZ')
      STOP
C
140   WRITE(6,7)
7     FORMAT(1H0,'BEFEHLE FEHLEN ODER SIND FALSCH')
      STOP
C
C           *****************************
C           ***   AUFRUF UP EINGAB    ***
C           *****************************
C
150   CLOSE (5,STATUS='KEEP')
      WRITE (*,'(1H ,''EINGAB'')')
      CALL  EINGAB  (KFEHL,AUST,NLAFA,NBE,NSOLL)
      CLOSE (50,STATUS='KEEP')
C
C        PRUEFEN, OB DIE BANDBREITE DER STRUKTUR
C        KLEINER ALS DIE VOM PROGRAMM FESTGELEGTE
C        UND DIE LAENGE DER GS-MATRIX KLEINER ALS
C        DIE IM PROGRAMM FESTGELEGTE LAENGE IST
C
      MBA = -0.5 + (0.25 + 2*LAD)**0.5
      WRITE (6,8) MBAND,LGS,MBA,LAV
8     FORMAT (/1H0,20X,'DIE BANDBREITE DER STRUKTUR IST ',I5,/
     *     1H ,20X,'DIE LAENGE DER GS-MATRIX IST ',I5,/
     *     1H ,20X,'DIE IM PROGRAMM FESTGELEGTEN GRENZEN SIND:',/
     *     1H ,20X,'BANDBREITE = ',I5,
     *     ', LAENGE DER GS-MATRIX = ',I5)
      IF (MBAND.LE.MBA.AND.LGS.LE.LAV) GOTO 160
      WRITE(6,10)
10    FORMAT(1H ,'IHRE STRUKTUR KANN NICHT BERECHNET WERDEN')
      STOP
C
160   IF(KFEHL.EQ.1.OR.RELE.EQ.NT) STOP
C           ********************************
C           ***  AUFRUF UP GESAMT  *********
C           ********************************
C
      WRITE (*,'(1H ,''GESAMT'')')
      CALL GESAMT
C
C           ********************************
C           *** AUFRUF UP RAND  ************
C           ********************************
C
      WRITE (*,'(1H ,''RAND'')')
      CALL RAND1 (AULA)
C
C           ********************************
C           ****   AUFRUF UP CHOLBA  *******
C           ********************************
C
      WRITE (*,'(1H ,''CHOLBA'')')
      CALL CHOLBA
C
C   ***************************************************
C   *  DO-SCHLEIFE UEBER DIE VERSCHIEDENEN LASTFAELLE *
C   ***************************************************
C
      DO 200   LF=1,NLAFA
      WRITE (6,9) LF
9     FORMAT (1H0,25X,24(1H*)/
     *        1H ,25X,'*ERGEBNISSE LASTFALL ',I2,'*'/
     *        1H ,25X,24(1H*))
C
      WRITE (*,'(1H ,''BELA'')')
      CALL BELA1 (LF,NBE,NSOLL)
C
      WRITE (*,'(1H ,''VORRUE'')')
      CALL VORRUE
C
      IF (LF .EQ. NLAFA) CLOSE (70,STATUS='DELETE')
C
      IF (AUVE .EQ. JA) CALL AUSVER (LF,PLOT)
C
      IF (AUSP .EQ. JA) CALL AUSSPA(LF)
C
      IF (AULA .EQ. JA) CALL AUFLAG(LF)
C
200   CONTINUE
      CLOSE (80,STATUS='DELETE')
      CLOSE (52,STATUS='DELETE')
      STOP
      END

C  ******************************************
C  ******************************************
C  ***    UNTERPROGRAMM EINGAB            ***
C  ******************************************
C  ******************************************
C  DAS UP  EINGAB LIEST DIE STRUKTURDATEI '50' UND
C  SCHREIBT DIE WERTE IN DATEIEN BZW. FELDER,
C  AUSSERDEM UEBERPRUEFUNG DER EINGABEDATEN
C******************************************************
C*    NEIN  : BELEGT MIT 'N'                          *
C*    I     : ZAEHLT DIE SAETZE AUS DER STRUKTURDATEI *
C*    MBAND : BANDBREITE DER GS-MATRIX                *
C*    LREF  : ANZAHL DER REFERENZEN.                  *
C*    LELE  : ANZAHL DER ELEMENTE.                    *
C*    LRAN  : ANZAHL DER RANDBEDINGUNGEN.             *
C*    KGRNR : GROESSTE EINGELESENE KNOTENNUMMER.      *
C*    LGS   : ANZAHL ZEILEN DER GS-MATRIX             *
C*    NLAFA : ANZAHL DER LASTFAELLE.                  *
C*    NBE:    ANZAHL DER BELASTUNGEN.                 *
C*    NSOLL : AUF 1 GESETZT, WENN SOLLVERSCHIEBUNGEN  *
C*            UNGLEICH 0 VORHANDEN SIND.              *
C*    ELEM  : BELEGT MIT 'ELEM'                       *
C*    REFE  : BELEGT MIT 'REFE'                       *
C*    RAND  : BELEGT MIT 'RAND'                       *
C*    BELA  : BELEGT MIT 'BELA'                       *
C*    STERN : BELEGT MIT '*'                          *
C*    ENDE  : BELEGT MIT 'ENDE'                       *
C*    IKSUM : SUMME DER KNOTENNUMMERN.                *
C*    IESUM : SUMME DER ELEMENTNUMMERN.               *
C*    IKO   : WIRD AUF 1 GESETZT, WENN DER DATENBLOCK *
C*            KOOR GEFUNDEN WURDE.                    *
C*    IEL   : WIRD AUF 1 GESETZT, WENN DER DATENBLOCK *
C*            ELEM GEFUNDEN WURDE.                    *
C*    IRE   : WIRD AUF 1 GESETZT, WENN DER DATENBLOCK *
C*            REFE GEFUNDEN WURDE.                    *
C*    IRA   : WIRD AUF 1 GESETZT, WENN DER DATENBLOCK *
C*            RAND GEFUNDEN WURDE.                    *
C*    IBE   : WIRD AUF 1 GESETZT, WENN DER DATENBLOCK *
C*            BELA GEFUNDEN WURDE.                    *
C*    IST   : NIMMT DEN STERN DES LETZTEN SATZES      *
C*            EINES DATENBLOCKS AUF                   *
C*    I3    : ANZAHL DER KNOTEN PRO ELEMENT           *
C*    MREFE : REFERENZNUMMER DER VORHER               *
C*            GELESENEN ZEILE IM DATENBLOCK ELEM      *
C*    KNANZ : ANZAHL KNOTEN PRO ELEMENT DER           *
C*            VORHER GELESENEN ZEILE AUS ELEM         *
C*    MK    : MAXIMALE KNOTENNUMMERNDIFFERENZ         *
C*            EINES ELEMENTS                          *
C*    ML    : GROESSTE KNOTENNUMMERNDIFFERENZ         *
C*            ALLER ELEMENTE                          *
C*    VERWENDETE FELDER                               *
C*    *****************                               *
C*                                                    *
C*    S     : NIMMT AUS DEM DATENBLOCK KOOR           *
C*            DIE KOORDINATEN AUF                     *
C*    I4    : NIMMT BEIM LESEN IM DATENBLOCK ELEM     *
C*            DIE NUMMERN  DER KNOTEN AUF.            *
C*    NAME  : ENTHAELT DIE NAMEN DER RANDBEDINGUNGEN  *
C*            AUS DEM *TYPEN-BEFEHL                   *
C*    REF   : DIE WERTE AUS DEM DATENBLOCK REFE       *
C*    KNRA  : KNOTENNUMMERN MIT RANDBEDINGUNGEN       *
C*    NARA  : NAMEN DER RANDBEDINGUNGEN AUS           *
C*            AUS DEM DATENBLOCK RAND                 *
C*    RV    : ENTHAELT DIE SOLLVERSCHIEBUNGEN         *
C*    AUFL  : NIMMT KRAEFTE AUF, DIE IN AUFLAGERN     *
C*            WIRKEN                                  *
C*    KNBE  : ENTHAELT DIE  KNOTENNUMMERN             *
C*    NULA  : ENTHAELT DIE  BELASTUNGSFAELLE          *
C*    BELAST: ENTHAELT DIE  BELASTUNGEN               *
C******************************************************
      SUBROUTINE   EINGAB (KFEHL,AUST,NLAFA,NBE,NSOLL)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER    ANZA,FREI
      CHARACTER*4 KOOR,ELEM,REFE,RAND,BELA,ENDE,TEXT
      CHARACTER STERN , NEIN ,AUST ,IST
      CHARACTER*2 NAME,NARA,NBLANK
      DIMENSION   S(3),I4(3)
      COMMON  /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON  /REFE/  REF(10,7)
      COMMON  /RAND/  KNRA(50),RV(50,6),AUFL(50,6)
      COMMON  /BELA/  KNBE(70),NULA(70),BELAST(70,6)
      COMMON  /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *                LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON  /CHAR/  NAME(6) , NARA(50,6)
      DATA   KOOR,ELEM,REFE,RAND,BELA,STERN,ENDE
     */'KOOR','ELEM','REFE','RAND','BELA','*','ENDE'/
C
      DATA   IESUM,IKSUM,IKO,IEL,IRE,IRA,IBE,
     *       I,ML,NEIN,NBLANK  /8*0,1,'N','  '/
      OPEN (50,FILE='FACH2',STATUS='OLD',ACCESS='SEQUENTIAL'
     *       ,FORM='FORMATTED')
      OPEN (52,FILE='E',STATUS='NEW',ACCESS='SEQUENTIAL'
     *       ,FORM='UNFORMATTED')
      KFEHL = 0
C
C         SUCHEN EINES DATENBLOCKNAMENS
C         IN DER STRUKTURDATEI
C
100   READ (50,1,END=700) TEXT
   1  FORMAT (A4)
      I = I + 1
      IF (TEXT.EQ.KOOR)  GOTO 1000
      IF (TEXT.EQ.ELEM)  GOTO 2000
      IF (TEXT.EQ.REFE)  GOTO 3000
      IF (TEXT.EQ.RAND)   GOTO 4000
      IF (TEXT.EQ.BELA)  GOTO 5000
      IF (TEXT.EQ.ENDE)  GOTO 300
      GOTO 100
C
300   IF(IKO*IEL*IRE*IRA*IBE.NE.0) RETURN
400   WRITE(6,2)
2     FORMAT(1H0,'DATENBLOCKNAME ODER KOMPLETTER '
     *           ,'DATENBLOCK FEHLT')
      KFEHL = 1
      RETURN
C
C          DATEIENDE GEFUNDEN, D.H. DER
C          EINGABEPARAMETER ENDE FEHLT
C
 700  WRITE (6,3)
3     FORMAT (1H0,'WARNUNG: ENDE-PARAMETER'
     *           ,' IN STRUKTURDATEI FEHLT')
      GOTO 300
C
C     *******************************
C     *   DATENBLOCK KOOR           *
C     *******************************
C
1000  IKO = 1
      KGRNR = 0
C
C            AUSDRUCKEN DES KOPFES FUER DEN
C            DATENBLOCK KOOR,FALLS AUST ='J'
C
      IF (AUST.EQ.NEIN)  GOTO 1100
      WRITE (6,4)
  4   FORMAT (1H0,25X,'KNOTENKOORDINATEN'/
     *        1H ,25X,17('=')/
     *        1H ,5X,'KNOTEN',9X,'X-KOORDINATE',
     *            9X,'Y-KOORDINATE')
      IF (KOANZ.NE.2)  WRITE (6,5)
  5   FORMAT (1H+,62X,'Z-KOORDINATE')
C
C        EINLESEN EINER ZEILE DES DATENBLOCKS KOOR
C        UND AUSDRUCKEN DER ZEILE, FALLS AUST ='J'
C
1100  READ (50,7,ERR=8000)  IST,I1,(S(J),J=1,KOANZ)
7     FORMAT(A1,I4,5X,3F10.0)
      I=I+1
      IF (AUST.EQ.NEIN)  GOTO 1200
      WRITE (6,8) I1,(S(J),J=1,KOANZ)
8     FORMAT (1H ,7X,I4,3(6X,F15.4))
C
C          FESTSTELLEN DER BISHER GROESSTEN KNOTENNUMMER
C
1200  IF (I1.GT.KGRNR) KGRNR=I1
C
C           FESTSTELLEN DER SUMME ALLER
C           BISHER GELESENEN KNOTENNUMMERN
C
      IKSUM = IKSUM + I1
C
C        SCHREIBEN DER KNOTENKOORDINATEN IN DAS FELD XKN
C
      NA = (I1-1)*KOANZ
      DO 1250 J = 1,KOANZ
1250  XKN(NA+J) = S(J)
C
C        PRUEFEN AUF * (LETZTE ZEILE IM DATENBLOCK)
C
      IF(IST.NE.STERN) GOTO 1100
C
C           FESTSTELLEN DER LAENGE DER GS-MATRIX
C
      IF(KGRNR*KOANZ.LE.LAX) GOTO 1300
      WRITE(6,6)
6     FORMAT(1H0,'FELD XKN DER KNOTENKOORDINATEN ZU KLEIN, ',
     *           'AENDERN SIE LAX UND DIE DIMENSION VON XKN')
      KFEHL = 1
1300  LGS=KGRNR*FREI
C
C            ERMITTELN DER THEORETISCHEN SUMME DER KNOTEN-
C            NUMMERN UND VERGLEICH MIT DER REALEN SUMME
C
      K=KGRNR*(KGRNR+1)/2
      IF (IKSUM.EQ.K)  GOTO 100
      WRITE (6,9)
   9  FORMAT (1H0,'FEHLER: KNOTENNUMMER IN KOOR FEHLT',
     *            ' IST DOPPELT ODER ES WURDEN NICHT ',
     *            'FORTLAUFENDE KNOTENNUMMERN VERWENDET')
      KFEHL=1
      GOTO 100
C
C     ********************************
C     *    DATENBLOCK ELEM           *
C     ********************************
C
2000  IEL = 1
C
C          VOREINSTELLEN DER ELEM-PARAMETER
C          'REFERENZ-NR' AUF 1 UND 'KNOTENANZAHL' AUF 2
C
      MREFE= 1
      KNANZ=2
C
      LELE = 0
C
C        AUSDRUCKEN DES KOPFES FUER DEN
C        DATENBLOCK ELEM, FALLS AUST = 'J'
C
      IF (AUST.EQ.NEIN)  GOTO  2100
      WRITE (6,10)
10    FORMAT (1H0,25X,'ANGABEN ZUR STRUKTUR'/
     *        1H ,25X,20('=')/
     *        1H ,5X,'ELEMENT',4X,'REFERENZ',
     *            2X,'KNOTENZAHL',3X,'KNOTEN'/)
C
C        EINLESEN EINER ZEILE DES DATENBLOCKS ELEM
C
2100  READ (50,11,ERR=8000) IST,I1,I2,I3,(I4(M),M=1,3)
11    FORMAT(A1,I4,5I5)
      I=I+1
      LELE = LELE + 1
C
C        FALLS KEINE KNOTENANZAHL ANGEGEBEN WURDE, WIRD DIE
C        KNOTENANZAHL DER VORHERGEHENDEN ZEILE UEBERNOMMEN
C        BZW. I3 = 2 AUS DER VOREINSTELLUNG FUER KNANZ
C
      IF (I3.EQ.0)  I3=KNANZ
      KNANZ=I3
C
C         FALLS IN DER ZEILE KEINE REFERENZ ANGEGEBEN WURDE,
C         WIRD DIE REFERENZ DER VORHERGEHENDEN ZEILE
C         UEBERNOMMEN BZW. WENN ES DIE ERSTE ZEILE DES DATEN-
C         BLOCKES ELEM IST, WIRD DIE VOREINSTELLUNG BENUTZT
C
      IF (I2.EQ.0)  I2=MREFE
      MREFE=I2
C
C         ERMITTELN DER SUMME DER BISHER
C         EINGELESENEN ELEMENTNUMMERN
C
      IESUM=IESUM+I1
C
C         FALLS IN DER BEFEHLSDATEI AUST='J'
C         AUSDRUCKEN DER ZEILE
C
      IF (AUST.EQ.NEIN)  GOTO 2200
      WRITE (6,12) I1,I2,I3,(I4(M),M=1,I3)
12    FORMAT (1H ,3(8X,I4),3(4X,I4))
C
C         ES WIRD DIE BANDBREITE DES ELEMENTS ERMITTELT
C         UND, WENN SIE GROESSER ALS ALLE BISHER BERECHNETEN
C         BANDBREITEN IST, IN DER VARIABLEN ML ABGESPEICHERT
C
2200  MK = 1
      DO 2300 M = 2,I3
      DO 2300 J = M,I3
      MZ = IABS (I4(J) - I4(M-1) )
      IF (MZ .GT. MK) MK = MZ
2300  CONTINUE
      IF(MK.GT.ML) ML = MK
C
C         RETTEN DER EINGELESENEN ZEILE
C
      WRITE (52) I1,I2,I3,(I4(M),M=1,I3)
C
C         PRUEFEN AUF * (LETZTE ZEILE IM DATENBLOCK)
C
      IF (IST.NE.STERN)  GOTO  2100
C
C         BANDBREITE DER GS-MATRIX
C
      MBAND = (ML+1)*FREI
      ENDFILE 52
C
C         VERGLEICH DER REALEN SUMME DER
C         ELEMENTE MIT DER THEORETISCHEN
C
      IF (IESUM.EQ.LELE*(LELE+1)/2) GOTO 100
      WRITE (6,13)
13    FORMAT (1H0,'FEHLER: ELEMENTNUMMER IN ELEM FEHLT, ',
     *'IST DOPPELT VORHANDEN ODER ES WURDEN NICHT FORT',
     *'LAUFENDE ELEMENTNUMMERN VERWENDET')
      KFEHL=1
      GOTO 100
C
C     ********************************
C     *      DATENBLOCK REFE         *
C     ********************************
C
3000  IRE = 1
C
C         AUSDRUCKEN DES KOPFES FUER DEN
C         DATENBLOCK FALLS AUST = 'J'
C
      IF (AUST.EQ.NEIN)  GOTO 3100
      WRITE (6,14)
  14  FORMAT (1H0,25X,'REFERENZEN'/
     *        1H ,25X,10('=')/
     *        1H ,3X,'NR.',4X,'REF. 1',4X,'REF. 2'
     *           ,4X,'REF. 3',4X,'REF. 4',4X,
     *           'REF. 5',4X,'REF. 6',4X,'REF. 7'/)
3100  J=1
3200  READ (50,15,ERR=8000) IST,NU,(REF(NU,L),L=1,7)
15    FORMAT(A1,I4,5X,7F10.0)
      IF(J.LE.10) GOTO 3250
      WRITE(6,18)
18    FORMAT (1H0,'MEHR ALS 10 VERSCHIEDENE REFERENZEN'///)
      KFEHL=1
      GOTO 100
3250  I = I + 1
C
C        AUSDRUCKEN DER ZEILE ,FALLS AUST ='J'
C
      IF (AUST.EQ.NEIN)  GOTO 3300
      WRITE (6,16) NU,(REF(NU,L),L=1,7)
16    FORMAT (1H ,2X,I4,7(1X,F9.2))
C
C        VERGLEICH DES GELESENEN ELEMENTTYPS MIT
C        DEN ELEMENTTYPEN AUS DER BEFEHLSDATEI
C
3300  DO 3400  NX=1,ANZA
      IF (REF(NU,1).EQ.ETYP(NX))  GOTO 3500
3400  CONTINUE
      WRITE (6,17) REF(NU,1)
  17  FORMAT (1H0,'FEHLER: ELEMENTTYP',E17.10,'STIMMT NICHT
     * MIT DEN IN DER BEFEHLSDATEI ANGEGEBENEN ELEMENTTYPEN
     * UEBEREIN')
      KFEHL = 1
C
C         PRUEFEN AUF * (LETZTE ZEILE IM DATENBLOCK)
C
3500  J = J + 1
      IF (IST.NE.STERN)  GOTO  3200
      LREF  = J - 1
      GOTO 100
C
C     *********************************
C     *     DATENBLOCK RAND           *
C     *********************************
C
4000  IRA = 1
      NSOLL = 0
C
C        AUSDRUCK DES KOPFES FUER DEN
C        DATENBLOCK RAND,FALLS AUST ='J'
C
      IF (AUST.EQ.NEIN)  GOTO 4100
      WRITE  (6,19)
19    FORMAT (1H0,25X,'RANDBEDINGUNGEN'/
     *        1H ,25X,15('=')/
     *        1H ,'KNOTEN',5X,
     *        'AUFGEZWUNGENGE VERSCHIEBUNGEN'/)
C
C         EINLESEN EINER ZEILE DES DATENBLOCKS RAND.
C
4100  J=1
4200  READ (50,20,ERR=8000) IST,KNRA(J),(NARA(J,M),
     *                      RV(J,M) ,M=1,3)
20    FORMAT(A1,I4,5X,3(A2,8X,F10.0))
      IF(FREI.GT.3)
     *READ(50,25,ERR=8000) IST,(NARA(J,M),RV(J,M),M=4,6)
25    FORMAT(A1,9X,3(A2,8X,F10.0))
      IF(J.LE.50) GOTO 4225
      WRITE (6,23)
23    FORMAT (1H0,'FEHLER: MEHR ALS 50 RANDBEDINGUNGEN')
      KFEHL=1
      GOTO 100
C
4225  I = I + 1
C
C       AUSDRUCKEN DER ZEILE, FALLS AUST ='J'
C
      IF (AUST.EQ.NEIN)  GOTO 4300
      WRITE(6,21) KNRA(J),(NARA(J,M),RV(J,M),M=1,FREI)
21    FORMAT (1H ,I4,2X,6(1X,A2,'=',E8.2))
C
C       VERGLEICH DER NAMEN DER RANDBEDINGUNGEN
C       MIT DENEN IM *TYPEN-BEFEHL
C
4300  DO  4400  M=1,FREI
      DO  4350  MM=1,FREI
      IF (NARA(J,M).EQ.NAME(MM).OR.NARA(J,M).EQ.NBLANK)
     *   GOTO 4380
4350  CONTINUE
      WRITE (6,22)  
22    FORMAT (1H0,'FALSCHER NAME FUER EINE RANDBEDINGUNG ',
     *        'BZW. NAME NICHT LINKSBUENDIG EINGETRAGEN')
      KFEHL=1
C
C         SETZEN DER VARIABLEN NSOLL AUF 1, FALLS
C         SOLLVERSCHIEBUNGEN UNGLEICH NULL VORHANDEN
C
4380  IF (RV(J,M).NE.0.) NSOLL=1
4400  CONTINUE
C
C         PRUEFEN AUF * (LETZTE ZEILE IM DATENBLOCK)
      J = J + 1
      IF(IST.NE.STERN)  GOTO  4200
      LRAN  = J - 1
      GOTO 100
C
C     ********************************
C     *   DATENBLOCK BELA            *
C     ********************************
C
5000  IBE = 1
      NLA = 1
      NLAFA = 0
C
C         AUSDRUCKEN DES KOPFES FUER DEN
C         DATENBLOCK BELA, FALLS AUST = 'J'
C
      IF (AUST.EQ.NEIN)  GOTO 5100
      WRITE (6,24) (NAME(MM),MM=1,FREI)
24    FORMAT (1H0,25X,'BELASTUNGEN'/
     *        1H ,25X,11('=')/
     *        1H ,'KNOTEN',1X,'LASTFALL'
     *           ,6(2X,A2,'-KOMP.'))
C
C         EINLESEN EINER ZEILE DES DATENBLOCKS BELA
C
5100  J=1
5200  READ (50,27,ERR=8000) IST,KNBE(J),NULA(J),
     *                      (BELAST(J,M),M=1,FREI)
27    FORMAT(A1,I4,I5,6F10.0)
      IF(J.LE.70) GOTO 5300
      WRITE (6,29)
29    FORMAT (1H0,'FEHLER: BELASTUNGEN AN MEHR ALS 70 ',
     *             'VERSCHIEDENEN KNOTEN'//)
      KFEHL=1
      GOTO 100
5300  I = I + 1
C
C         UEBERNAHME DES BELASTUNGSFALLS AUS DER
C         VORHERGEHENDEN ZEILE, FALLS IN DIESER ZEILE
C         KEIN BELASTUNGSFALL ANGEGEBEN WURDE
C
      IF (NULA(J).EQ.0)  NULA(J)=NLA
      NLA=NULA(J)
C
C        AUSDRUCKEN DER ZEILE, FALLS AUST ='J'
C
      IF (AUST.EQ.NEIN)  GOTO 5400
      WRITE (6,28)  KNBE(J),NULA(J),(BELAST(J,M),M=1,FREI)
28    FORMAT (1H ,I4,4X,I4,3X,6E10.3)
C
C        ABSPEICHERN DER BISHER GROESSTEN
C        LASTFALLNUMMER IN DER VARIABLEN NLAFA
C
5400  IF (NLAFA.LT.NLA) NLAFA=NLA
C
C        PRUEFEN AUF * (LETZTE ZEILE IM DATENBLOCK)
C
      J = J + 1
      IF (IST.NE.STERN)  GOTO 5200
      NBE = J - 1
      GOTO 100
C
C        FEHLERMELDUNG, FALLS EIN FEHLER BEIM
C        LESEN EINER ZEILE DES DATENBLOCKS AUFTRAT
C
8000  I = I + 1
      WRITE (6,30) I
30    FORMAT (1H0,'EINLESEFEHLER IN ZEILE',I5/
     *        1H ,'MOEGLICHER FEHLER: STERN FEHLT'/
     *        1H ,13X,'ODER: FALSCHER ZAHLTYP'/
     *        1H ,13X, 'ODER: ZAHL NICHT IM EINGABEFELD'/)
      KFEHL=1
      GOTO 100
      END

C  *****************************************
C  *****************************************
C  ***    UNTERPROGRAMM GESAMT       *******
C  *****************************************
C  *****************************************
C  DAS UNTERPROGRAMM GESAMT ERSTELLT DIE RECHTE
C  HAELFTE DES BANDES DER GS-MATRIX
C************************************************************
C*    NZEI  : ZEILE DER GS-MATRIX, DIE BEARBEITET WIRD      *
C*    I1    : ELEMENTNUMMER                                 *
C*    I2    : REFERENZNUMMER DES ELEMENTES                  *
C*    I3    : ANZAHL DER KNOTEN DES ELEMENTES               *
C*    NSPA  : SPALTE DER GS-MATRIX, DIE BEARBEITET WIRD     *
C*    VERWENDETE FELDER                                     *
C*    A     : FELD FUER EINE ZEILE DES BANDES DER GS-MATRIX *
C*    ELST  : FELD FUER DIE ES-MATRIX                       *
C*    I4    : ENTHAELT DIE AN EINEM ELEMENT BETEILIGTEN     *
C*            KNOTENNUMMERN                                 *
C*    X     : KOORDINATEN DER KNOTEN EINES ELEMENTS         *
C************************************************************
      SUBROUTINE  GESAMT
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      DIMENSION    X(3,3),I4(3)
C
      COMMON  /FELD/  A(110),D(6105),XID(500),XKN(500)
      COMMON  /REFE/  REF(10,7)
      COMMON  /ES/    ELST (12,12)
      COMMON  /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *                LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
      OPEN (70,FILE='G',STATUS='NEW',ACCESS='DIRECT'
     *        ,RECL=8*MBAND,FORM='UNFORMATTED')
C
C         DATEI '52' AUF DEN ANFANG SETZEN
C
      REWIND 52
C       
C       FELD XID DIENT ZUR KENNZEICHNUNG,
C       OB EIN SATZ AUS '70' ERSTMALIG GELESEN WIRD
C
      DO 1000 M = 1 , LGS
1000  XID(M) = 0.
      DO 8000  LL=1,LELE
C
C         EINLESEN EINER ZEILE AUS ELEM
C
      READ (52)  I1,I2,I3,(I4(M),M=1,I3)
C
C         SUCHEN DER KNOTENKOORDINATEN IM FELD XKN
C
      DO 2000  M=1,I3
      NA = (I4(M)-1)*KOANZ
      IF(I4(M).GT.KGRNR) GOTO 9000
      DO 2000 J = 1,KOANZ
      X(M,J) = XKN(NA+J)
2000  CONTINUE
C
C        AUFRUF EINES UP'S ZUM ERSTELLEN DER
C        ES-MATRIX JE NACH ELEMENTTYP
C
      IF(REF(I2,1).NE.4.) GOTO 3110
      CALL STAB (X,REF(I2,2),REF(I2,3))
      GOTO 3200
3110  IF(REF(I2,1).NE.1.) GOTO 3120
      CALL DREI (X,REF(I2,2),REF(I2,3),REF(I2,4))
      GOTO 3200
3120  IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.3)) GOTO 3130
      CALL BALK2(X,REF(I2,2),REF(I2,3),REF(I2,4))
      GOTO 3200
3130  IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.6)) GOTO 3140
      CALL BALK3(X,REF(I2,2),REF(I2,3),REF(I2,4)
     *  ,REF(I2,5),REF(I2,6),REF(I2,7))
      GOTO 3200
3140    WRITE (6,10) REF(I2,1)
10      FORMAT (1H0 ,'ELEMENTTYP ',F5.2,' NICHT VORHANDEN')
        STOP
C
3200  N = 0
      DO 8000  II=1,I3
      DO 8000  I=1,FREI
C
      N = N + 1
C
C         ZEILENNUMMER DER GS-MATRIX, AUF DIE EINE
C         ZEILE DER ES-MATRIX AUFADDIERT WIRD
C
      NZEI = (I4(II) - 1)*FREI + I
C
C          LESEN DER ZEILE DER GS-MATRIX AUS DER DATEI '70'
C
      IF (XID(NZEI) .GT. 0.) THEN
        READ (70,REC=NZEI) (A(L),L=1,MBAND)
      ELSE
C
C         A WIRD AUF 0 INITIALISIERT,WENN DIE EINZULESENDE
C         ZEILE AUF DATEI '70' NOCH NICHT VORHANDEN WAR
C
        DO 4600  L=1,MBAND
4600    A(L)=0.
      ENDIF
C
C         ERMITTELN DER SPALTE UND PRUEFEN, OB DAS
C         ELEMENT DER ES-MATRIX IM BAND LIEGT, ANDERNFALLS
C         SPRUNG ZUR ERMITTLUNG DER NAECHSTEN SPALTE
C
5000  M = 0
      DO 6000  JJ=1,I3
      DO 6000  J=1,FREI
      M = M + 1
      NSPA =(I4(JJ)-1)*FREI+J
      IF (NSPA.LT.NZEI) GOTO 6000
C
C         ERMITTLUNG DES INDEX L DER A-ZEILE
C
      L= NSPA - NZEI + 1
      IF (M .GT. N) GOTO 5500
      A(L) = A(L) + ELST(M,N)
      GOTO 6000
5500  A(L) = A(L) +  ELST(N,M)
6000  XID(NZEI) = 1.
C
C        ZURUECKSCHREIBEN DER ZEILE IN DIE DATEI '70'
C
      WRITE (70,REC=NZEI)  (A(K),K=1,MBAND)
8000  CONTINUE
      RETURN
9000  WRITE (6,1) I4(M)
1     FORMAT(1H ,'ENDE DES FELDES XKN GEFUNDEN '/
     *           'MOEGLICHER FEHLER: KNOTEN ',I5,' FEHLT')
      STOP
      END

C  ******************************
C  ******************************
C  ***  UNTERPROGRAMM CHOLBA  ***
C  ******************************
C  ******************************
C  CHOLBA ERSTELLT MIT DEM CHOLESKY-
C  VERFAHREN DIE RECHTSDREIECKSMATRIX R
C
      SUBROUTINE  CHOLBA
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  FREI,ANZA
C
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
      ND = MBAND - 1
      LD =  MBAND*(MBAND + 1)/2
      L = LD - ND
C
      DO 500 I = 1,LD
500   D(I) = 0.
C
      NF = LGS + 1
C
C       DURCHGANG DURCH ALLE ZEILEN DES BANDES
C
      DO 900 NZ = 1,NF
C
C       AKTUALISIEREN DES "DREIECKS" MIT DEM UP DORG
C
      CALL DORG (NZ,L,LD,ND,1)
      IF (NZ.EQ.NF)  RETURN
C
C         BERECHNEN DER ELEMENTE EINER ZEILE VON R
C
      DO 900 J = 1,MBAND
      M = L + J - 1
      IF(J.EQ.MBAND) GOTO 870
      DO 850 K = J,ND
      NS =  K*(K - 1)/2 + 1
      D(M) = D(M) - D(NS)*D(NS + J - 1)
850   CONTINUE
C
C       DIAGONALELEMENT BERECHNEN BEI J = 1
C
      IF(J.NE.1) GOTO 870
C
C       FEHLER, FALLS DIAGONALELEMENT KLEINER 0
C
      IF(D(L).LE.0.) GOTO 4444
4443  D(L) = D(L)**0.5
      GOTO 900
C
870   D(M) = D(M)/D(L)
C
900   CONTINUE
C
4444  WRITE(6,1)  NZ
1     FORMAT(1H0,'GLEICH.-SYSTEM MIT CHOLESKY NICHT LOESBAR, ',
     *           1H ,'DA IN DER ZEILE ',I5,' DAS DIAGONAL-',
     *           1H ,'ELEMENT DER RECHTSMATRIX R NEGATIV IST'/
     *           1H ,'MOEGL. FEHLER: GS-MATRIX SINGULR, DA ZU
     *                WENIGE RANDBEDINGUNGEN '/
     *           1H ,'ODER BEI ZU GROSSER STRUKTUR SINGULARITT
     *                WEGEN RUNDUNGSFEHLERN')
      STOP
      END

C  *******************************
C  *******************************
C  ***   UNTERPROGRAMM VORRUE ****
C  *******************************
C  *******************************
C  DAS UNTERPROGRAMM VORRUE ERMITTELT DIE VERSCHIEBUNGEN
C  DURCH VOR- UND RUECKWAERTSEINSETZEN IN DIE MATRIX R
C************************************************************
C*    VERWENDETE VARIABLEN                                  *
C*                                                          *
C*    NZ    : ZEILE AUS DER RECHTSMATRIX                    *
C*                                                          *
C*    VERWENDETE FELDER                                     *
C*                                                          *
C*    D     : "DREIECKSMATRIX", MIT DER BEIM VORWAERTS-     *
C*            EINSETZEN DIE ZWISCHENLOESUNG BERECHNET WIRD  *
C*    V     : VERSCHIEBUNGSVEKTOR, ENTHAELT NACH VORWAERTS- *
C*            EINSETZEN DIE ZWISCHENLOESUNG, NACH DEM       *
C*            RUECKWAERTSEINSETZEN DIE VERSCHIEBUNGEN       *
C************************************************************
      SUBROUTINE VORRUE 
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C              ANFANGS- UND ENDADRESSE DER
C              UNTERSTEN ZEILE DES "DREIECKS"
C
      LD = MBAND*(MBAND + 1)/2
      ND= MBAND - 1
      L = LD - ND
C              ****************************
C              *** VORWAERTSEINSETZEN  ****
C              ****************************
      DO 500 NZ = 1,LGS
C
C              AKTUALISIEREN DES "DREIECKS" UND
C              LESEN EINER ZEILE AUS DER DATEI '70'
C
      CALL DORG (NZ,L,LD,ND,0)
C
C              BERECHNEN DER NZ. KOMPONENTE
C              DER ZWISCHENLOESUNG
C
      DO 400 J = 1,ND
      NA = J*(J-1)/2 + 1
      NB = NZ - MBAND + J
      IF (NB.LE.0) GOTO 400
      V(NZ) = V(NZ) - D(NA)*V(NB)
400   CONTINUE
      V(NZ) = V(NZ)/D(L)
500   CONTINUE
C
C              *****************************
C              *** RUECKWAERTSEINSETZEN ****
C              *****************************
C
      DO 800 N = 1,LGS
C
C                LESEN DER SAETZE AUS DER
C                DATEI '70' VON HINTEN
C
      NZ = LGS - N + 1
      READ(70,REC=NZ) (D(I) , I = L,LD)
C
C                BERECHNEN DER NZ. KOMPONENTE
C                DES LOESUNGSVEKTORS
C
      DO 600 J = 1,ND
      NA = L + J
      NB = NZ + J
      IF (NB.GT.LGS) GOTO 600
      V(NZ) = V(NZ) - D(NA)*V(NB)
600   CONTINUE
      V(NZ) = V(NZ)/D(L)
800   CONTINUE
      RETURN
      END

C  *****************************
C  *****************************
C  *** UNTERPROGRAMM AUSVER ****
C  *****************************
C  *****************************
C  DAS UNTERPROGRAMM AUSVER
C  DRUCKT DIE VERSCHIEBUNGEN
C******************************************
C*  LF     : BELASTUNGSFALL.              *
C*  KGRNR  : GROESSTE KNOTENNUMMER.       *
C*  VERS   : VERSCHIEBUNGSVEKTOR          *
C******************************************
      SUBROUTINE AUSVER (LF,PLOT)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER      FREI,ANZA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/  NAME(6) , NARA(50,6)
C
      CHARACTER*2 NAME , NARA , PLOT*1 , NEIN*1
      DATA  NEIN /'N'/
C
C         DRUCKEN DES KOPFES
C
      WRITE (6,1)
   1  FORMAT (1H0,25X,'VERSCHIEBUNGEN DER STRUKTUR'/
     *            1H ,25X,27('=')/
     *            1H0,'KNOTEN',20X,'VERSCHIEBUNGEN')
      WRITE (6,2) (NAME(J),J=1,FREI)
   2  FORMAT (1H0,14X,6(A2,10X))
      DO 1000  I=1,KGRNR
      NA  = (I-1)*FREI+1
      NE  = NA +FREI-1
C
C         DRUCKEN DER VERSCHIEBUNGEN
C
      WRITE (6,4) I,(V(N),N=NA,NE)
   4  FORMAT (1H ,I5,3X,6(E11.5,1X))
C
1000  CONTINUE
C
C       VERSCHIEBUNGEN IN DIE DATEI '99'
C
      IF (PLOT .EQ. NEIN) RETURN
      OPEN (99,FILE='P',STATUS='NEW',ACCESS='SEQUENTIAL'
     *        ,FORM='FORMATTED')
      DO 2000 I = 1,KGRNR
      NA = (I-1)*FREI + 1
      NE = NA + KOANZ - 1
2000  WRITE (99,5) I , (V(J) , J = NA,NE)
5     FORMAT (I5,3X,3(E12.4))
      RETURN
      END

C  ******************************
C  ******************************
C  ****  UNTERPROGRAMM AUSSPA ***
C  ******************************
C  ******************************
C  DAS UNTERPROGRAMM AUSSPA DRUCKT DEN KOPF
C  UND RUFT DIE UNTERPROGRAMME ZUR
C  SPANNUNGSBERECHNUNG AUF
C******************************************
C*  LF     : BELASTUNGSFALL.              *
C******************************************
      SUBROUTINE  AUSSPA (LF)
      IMPLICIT REAL*8  (A-H,O-Z)
C
      INTEGER      FREI,ANZA
      DIMENSION  I4(3),X(3,3)
C
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /REFE/  REF(10,7)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
      REWIND 52
C
C         DRUCKEN DES KOPFES
C
      WRITE (6,1)
   1  FORMAT (1H0,25X,'KRAEFTE,SPANNUNGEN UND MOMENTE'/,
     *            1H ,25X,30('=')/1H ,' ELEMENT   KNOTEN ')
      DO 1000  L =1,LELE
C
C         LESEN EINES ELEMENTS AUS DER DATEI '52'
      READ (52)  I1,I2,I3,(I4(M),M=1,I3)
C
C             SUCHEN DER KNOTENKOORDINATEN IM FELD XKN
C
      DO 200   M=1,I3
      NA = (I4(M)-1)*KOANZ
      DO 200 J = 1,KOANZ
      X(M,J) = XKN(NA+J)
200   CONTINUE
C
C     JE NACH ELEMENTTYP AUFRUF DES UP'S ZUR BERECHNUNG
C     DER KRAEFTE UND SPANNUNGEN.
C
400   IF(REF(I2,1).NE.4.) GOTO 900
      CALL SPA4(I1,I4,X,REF(I2,2),REF(I2,3))
      GOTO 1000
900   IF(REF(I2,1).NE.1.) GOTO 910
      CALL SPA1(I1,I4,X,REF(I2,3),REF(I2,4))
      GOTO 1000
910   IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.3)) GOTO 920
      CALL SPA92(I1,I4,X,REF(I2,2),REF(I2,3),REF(I2,4))
      GOTO 1000
920   IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.6)) GOTO 930
      CALL SPA93(I1,I4,X,L,REF(I2,2),REF(I2,3),REF(I2,4),
     *             REF(I2,5),REF(I2,6),REF(I2,7))
      GOTO 1000
930   WRITE (6,2) REF(I2,1)
2     FORMAT (1H0,'ELEMENTTYP ',F5.2,' NICHT VORHANDEN')
      STOP
C
1000  CONTINUE
      RETURN
      END

C  ****************************
C  ****************************
C  ***  UNTERPROGRAMM AUFLAG **
C  ****************************
C  ****************************
C  DAS UNTERPROGRAMM AUFLAG ERMITTELT UND DRUCKT
C  DIE AUFLAGERREAKTIONEN DES BAUTEILS
C************************************************
C*  NZEI   : ZEILE DER GS-MATRIX                *
C*           DIE ZU BEARBEITEN IST              *
C*  NA     : ADRESSE FUER DEN ERSTEN WERT EINER *
C*           EINER ZEILE AUS DER DATEI '80'     *
C*  NE     : ENDADRESSE EINER ZEILE VON '80'    *
C*  F      : AUFLAGERREAKTIONSKRAFT.            *
C************************************************
      SUBROUTINE AUFLAG  (LF)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      CHARACTER*2 NAME , NARA
C
      COMMON /RAND/ KNRA(50),RV(50,6),AUFL(50,6)
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/ NAME(6) , NARA(50,6)
C
      REWIND 80
      MDA = MBAND * 2 - 1
C
C         DRUCKEN DES KOPFES
C
      WRITE  (6,1)
    1 FORMAT (1H0,25X,'AUFLAGERREAKTIONEN'/
     *        1H ,25X,18('=')/1H ,'KNOTEN')
      DO 1000  I =1,LRAN
      DO 1000  J =1,FREI
      DO 1000  K =1,FREI
C
C         SUCHEN EINER RANDBEDINGUNG UND
C         LESEN DER ZEILE AUS DER DATEI '80'
C
      IF (NARA(I,J).NE.NAME(K))  GOTO 1000
      NZEI=(KNRA(I)-1)*FREI+K
      READ(80) (D(L), L = 1,MDA)
      NA = NZEI - MBAND + 1
      IF(NA.LE.0) NA = 1
      NE = NZEI + MBAND - 1
      IF(NE.GT.LGS)  NE = LGS
      F = 0.
C
C         BERECHNEN DER AUFLAGERKRAEFTE
C
      DO 500 L = NA,NE
500   F = F + D(L-NA+1)*V(L)
C
C        EINGEPRAEGTE KRAEFTE IN DEN 
C        AUFLAGERN BERUECKSICHTIGEN
C
      F = F - AUFL(I,J)
C
C         DRUCKEN DER AUFLAGERREAKTIONEN
C
      WRITE (6,2) NAME(K)
2     FORMAT(1H ,10X,A2,'-KOMPONENTE: ')
      WRITE (6,5) KNRA(I),F
5     FORMAT (1H+,I5,20X,E12.3)
1000  CONTINUE
      RETURN
      END

C  ********************************
C  ********************************
C  ***   UNTERPROGRAMM STAB  ******
C  ********************************
C  ********************************
C  DAS UNTERPROGRAMM STAB ERSTELLT DIE
C  ES-MATRIX FUER DAS STRUKTURELEMENT STAB
C**************************************************
C*  DX    : DIFFERENZ DER X-KOORDINATEN           *
C*  DY    : DIFFERENZ DER Y-KOORDINATEN           *
C*  DZ    : DIFFERENZ DER Z-KOORDINATEN           *
C*  G     : E*AR/STL                              *
C*  E     : ELASTIZITAETSMODUL DES STABMATERIALS  *
C*  AR    : QUERSCHNITTSFLAECHE DES STABES        *
C*  STL   : LAENGE DES STABES                     *
C*  CALPHA: RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE X-ACHSE                       *
C*  CBETA : RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE Y-ACHSE                       *
C*  CGAMMA: RICHTUNGSCOSINUS DES STABES           *
C*          AUF DIE Z-ACHSE                       *
C*                                                *
C*  VERWENDETE FELDER                             *
C*                                                *
C*  X     : KNOTENKOORDINATEN DES STABES,         *
C*  ELST  : ES-MATRIX                             *
C**************************************************
      SUBROUTINE  STAB (X,E,AR)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  FREI , ANZA
      DIMENSION    X(3,3)
C
      COMMON  /ES/   ELST(12,12)
      COMMON  /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      DZ = 0.
      CGAMMA = 0.
      DX = X(2,1) - X(1,1)
      DY = X(2,2) - X(1,2)
      IF (FREI .EQ. 3) DZ = X(2,3) - X(1,3)
C
C          BESTIMMUNG DER STABLAENGE
C
      STL = (DX**2 + DY**2 + DZ**2)**0.5
C
C          BESTIMMUNG DER RICHTUNGSCOSINUS
C
      CALPHA = DX/STL
      CBETA = DY/STL
      IF (FREI .EQ. 3) CGAMMA = DZ/STL
C
C          BERECHNUNG DES SKALARS G
C
      G = AR*E/STL
C
C         BERECHNUNG DER RECHTEN TEILMATRIX,
C         ELEMENTE FUER DIE 2D- UND 3D-MATRIX
C
      ELST(1,1) = G*CALPHA**2
      ELST(1,2) = G*CALPHA*CBETA
      ELST(2,2) = G*CBETA**2
C
C
C         ELEMENTE FUER DIE 3D-MATRIX
C
      IF (FREI .EQ. 2) GOTO 100
      ELST(1,3) = G*CALPHA*CGAMMA
      ELST(1,4) = - ELST(1,1)
      ELST(1,5) = - ELST(1,2)
      ELST(1,6) = - ELST(1,3)
C
      ELST(2,3) = G*CBETA*CGAMMA
      ELST(2,4) = - ELST(1,2)
      ELST(2,5) = - ELST(2,2)
      ELST(2,6) = - ELST(2,3)
C
      ELST(3,3) = G*CGAMMA**2
      ELST(3,4) = - ELST(1,3)
      ELST(3,5) = - ELST(2,3)
      ELST(3,6) = - ELST(3,3)
C
      ELST(4,4) = ELST(1,1)
      ELST(4,5) = ELST(1,2)
      ELST(4,6) = ELST(1,3)
C
      ELST(5,5) = ELST(2,2)
      ELST(5,6) = ELST(2,3)
C
      ELST(6,6) = ELST(3,3)
C
      RETURN
C
C         ELEMENTE FUER DIE 2D-MATRIX
C
100   ELST(1,3) = - ELST(1,1)
      ELST(1,4) = - ELST(1,2)
C
      ELST(2,3) = - ELST(1,2)
      ELST(2,4) = - ELST(2,2)
C
      ELST(3,3) = ELST(1,1)
      ELST(3,4) = ELST(1,2)
C
      ELST(4,4) = ELST(2,2)
      RETURN
      END

C    *************************
C    *************************
C    *** UNTERPROGRAMM SPA1***
C    *************************
C    *************************
C    DAS UNTERPROGRAMM SPA1 ERMITTELT DIE SPANNNUNGEN
C    UND DEHNUNGEN IM DREIECKSELEMENT UND DRUCKT SIE
C*********************************************
C*    VERWENDETE VARIABLEN                   *
C*                                           *
C*    E        :ELASTIZITAETSMODUL           *
C*    Q        :QUERZAHL                     *
C*    FL       :FLAECHENINHALT DES DREIECKES *
C*    DA-DF    :KOORDINATENDIFFERENZEN       *
C*    SIGMA XX :NORMALSPANNUNG IN X-RICHTUNG *
C*    SIGMA YY :NORMALSPANNUNG IN Y-RICHTUNG *
C*    TAU XY   :SCHUBSPANNUNG                *
C*                                           *
C*    VERWENDETE FELDER                      *
C*                                           *
C*    S        :SPANNUNGSMATRIX              *
C*    X        :KNOTENKOORDINATEN DES VER-   *
C*              WENDETEN DREIECKS            *
C*    V        :VERSCHIEBUNGSVEKTOR          *
C*********************************************
      SUBROUTINE SPA1 (I1,I4,X,E,Q)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER       FREI,ANZA
      DIMENSION        X(3,3),I4(3),S(3,6),Z(3)
C
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      DO 5  K = 1,3
      Z ( K ) = 0.
5     CONTINUE
      DA=X(3,2)-X(2,2)
      DB=X(3,1)-X(2,1)
      DC=X(1,2)-X(3,2)
      DD=X(1,1)-X(3,1)
      DE=X(2,2)-X(1,2)
      DF=X(2,1)-X(1,1)
C
C         FLAECHENINHALT DES DREIECKS
C
      FL=0.5*(DF*DA-DB*DE)
C
      F=(1.-Q)/2.
C
C          SPANNUNGSMATRIX
C
      S(1,1)=-DA
      S(1,2)=DB*Q
      S(1,3)=-DC
      S(1,4)=DD*Q
      S(1,5)=-DE
      S(1,6)=DF*Q
      S(2,1)=S(1,1)*Q
      S(2,2)=S(1,2)/Q
      S(2,3)=S(1,3)*Q
      S(2,4)=S(1,4)/Q
      S(2,5)=S(1,5)*Q
      S(2,6)=S(1,6)/Q
      S(3,1)=DB*F
      S(3,2)=-DA*F
      S(3,3)=DD*F
      S(3,4)=-DC*F
      S(3,5)=DF*F
      S(3,6)=-DE*F
C
      B=E/((1.-Q**2)*2.*FL)
C
C     BERECHNUNG DES SPANNUNGSVEKTORS
C
      DO 10 I=1,2
      DO 10 J=2,6,2
      DO 10 K=1,3
      J1=J+I-2
      J2=(I4(J/2)-1)*FREI+I
      Z(K)=Z(K)+S(K,J1)*V(J2)
10    CONTINUE
C
      SIGXX=Z(1)*B
      SIGYY=Z(2)*B
      TAUXY=Z(3)*B
C
C           DRUCKEN
C
      WRITE (6,1) I1,SIGXX,SIGYY,TAUXY
1     FORMAT (1H ,3X,I5,10X,'SIGMAXX= ',F7.2,
     *'  SIGMAYY= ',F7.2,'  TAUXY= ',F7.2)
      RETURN
      END

C  **************************
C  **************************
C  *** UNTERPROGRAMM SPA4 ***
C  **************************
C  **************************
C  DAS UNTERPROGRAMM SPA4 ERMITTELT DIE KRAEFTE
C  UND SPANNUNGEN IN STABELEMENTEN UND DRUCKT SIE
C*************************************************
C*  E      : ELASTIZITAETSMODUL.                 *
C*  AR     : QUERSCHNITT.                        *
C*  DX     : DIFFERENZ DER X-KOORDINATEN         *
C*  DY     : DIFFERENZ DER Y-KOORDINATEN.        *
C*  DZ     : DIFFERENZ DER Z-KOORDINATEN.        *
C*  STL    : LAENGE DES STABES.                  *
C*  CALPHA : RICHTUNGSCOSINUS GEGEN DIE X-ACHSE  *
C*  CBETA  : RICHTUNGSCOSINUS GEGEN DIE Y-ACHSE  *
C*  CGAMMA : RICHTUNGSCOSINUS GEGEN DIE Z-ACHSE  *
C*  N1     : ANFANGSKOMPONENTE IM VERSCHIEBUNGS- *
C*           VEKTOR FUER DEN 1. KNOTEN           *
C*  N2     : ANFANGSKOMPONENTE IM VERSCHIEBUNGS- *
C*           VEKTOR FUER DEN 2. KNOTEN           *
C*  F      : KRAFT IM STAB.                      *
C*  SIGMA  : NORMALSPANNUNG IM STAB              *
C*************************************************
      SUBROUTINE SPA4 (I1,I4,X,E,AR)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      DIMENSION       X(3,3),I4(3)
C
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C          KOORDINATENDIFFERENZEN
C
      DZ = 0.
      DX=X(2,1)-X(1,1)
      DY=X(2,2)-X(1,2)
      IF (FREI.EQ.3) DZ = X(2,3) - X(1,3)
C
C          LAENGE DES STABES
C
      STL=(DX**2+DY**2+DZ**2)**.5
C
C         BESTIMMUNG DER RICHTUNGSCOSINUS
C
      CGAMMA=DZ/STL
      CBETA=DY/STL
      CALPHA=DX/STL
C
C         KOMPONENTEN DER BENOETIGTEN VERSCHIEBUNGEN
C
      N1=(I4(1)-1)*FREI+1
      N2=(I4(2)-1)*FREI+1
C
      DU= CALPHA*(V(N2)-V(N1))+CBETA*(V(N2+1)-V(N1+1))
      IF (FREI.EQ.3) DU = DU + CGAMMA*(V(N2+2) - V(N1+2))
C
C         BESTIMMUNG DER KRAFT IM STAB.
C
      F=DU*AR*E/STL
C
C         BERECHNUNG DER SPANNUNG
C
      SIGMA = F/AR
C
C         DRUCKEN DER KNOTENNUMMER,KRAFT UND SPANNUNG
C
      WRITE (6,1)  I1,F,SIGMA
   1  FORMAT (1H ,3X,I5,10X,'F = ',F12.3,'  SIGMA = ',F12.3)
      RETURN
      END

C  ***************************
C  ***************************
C  *** UNTERPROGRAMM SPA92 ***
C  ***************************
C  ***************************
C  DAS UNTERPROGRAMM SPA92 ERMITTELT DIE KRAEFTE UND
C  MOMENTE AN EBENEN BALKENELEMENTEN UND DRUCKT SIE
C******************************************************
C*   VERWENDETE VARIABLEN                             *
C*                                                    *
C*   I1     : ELEMENTNUMMER                           *
C*   XL;YL  : ACHSENABSCHNITTE                        *
C*   E      : ELASTIZITAETSMODUL                      *
C*   AR     : QUERSCHNITTSFLAECHE                     *
C*   TRZ    : FLAECHENTRAEGHEITSMOMENT BEZUEGLICH     *
C*            DER LOKALEN Z-ACHSE                     *
C*   CA;SA  : RICHTUNGSCOSINUS ZU DEN GLOBALEN ACHSEN *
C*                                                    *
C*   VERWENDETE FELDER                                *
C*                                                    *
C*   X      : KNOTENKOORDINATEN                       *
C*   FV     : MATRIZENPRODUKT                         *
C*   F      : KRAFTVEKTOR                             *
C*   I4     : BETEILIGTE KNOTENNUMMERN                *
C******************************************************
      SUBROUTINE SPA92 (I1,I4,X,E,AR,TRZ)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER          FREI, ANZA
      DIMENSION   X(3,3),FV(3,6),F(6),I4(3)
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C          INITIALISIEREN DES KRAFTVEKTORS
C
      DO   5  J= 1,6
5     F(J) = 0.
C
C        KOORDINATENDIFFERENZEN UND RICHTUNGSCOSINUS
C
      XL = X(2,1) - X(1,1)
      YL = X(2,2) - X(1,2)
      STL= (XL**2+YL**2)**0.5
      CA = XL/STL
      SA = YL/STL
C
C        SKALARE AUS DER LOKALEN ES-MATRIX
C
      FO = E*TRZ/STL**3
      A11= E*AR/STL
      A22=12.*FO
C
C        MATRIZENPRODUKT AUS TRANSFORMATIONSMATRIX
C        UND LOKALER ES-MATRIX
C
      FV(1,1) = CA*A11
      FV(1,4) =-FV(1,1)
      FV(1,2) = SA*A11
      FV(1,5) =-FV(1,2)
      FV(1,3) = 0.
      FV(1,6) = 0.
      FV(2,1) =-SA*A22
      FV(2,4) =-FV(2,1)
      FV(2,2) = CA*A22
      FV(2,5) =-FV(2,2)
      FV(2,3) = 6.*STL*FO
      FV(2,6) = FV(2,3)
      FV(3,1) =-SA*FV(2,3)
      FV(3,4) =-FV(3,1)
      FV(3,2) = CA*FV(2,3)
      FV(3,5) =-FV(3,2)
      FV(3,3) = 4.*FO*STL**2
      FV(3,6) = FV(3,3)/2.
C
C        ERMITTLUNG DES KRAFTVEKTORS
C
      DO  10  J = 1,3
      DO  10  I = 1,2
      DO  10  K = 1,3
      J1 = (I4(I)-1)*FREI+K
      J2 = (I-1)*FREI+K
10    F(J) = F(J) + V(J1)*FV(J,J2)
C
      F(4) =-F(1)
      F(5) =-F(2)
      F(6) = F(3) - (FV(3,3)*V((I4(1)-1)*FREI+3)
     *            +  FV(3,6)*V((I4(2)-1)*FREI+3))
     *            + (FV(3,3)*V((I4(2)-1)*FREI+3)
     *            +  FV(3,6)*V((I4(1)-1)*FREI+3))
C
      WRITE (6,1) I1,I4(1),F(1),F(2),F(3),I4(2),
     *                     F(4),F(5),F(6)
1     FORMAT (1H ,3X,I5,2(3X,I5,3X,'FLAENGS= ',E11.5,
     *        3X,'FQUER= ',E11.5,3X,'MBZ=  ',E11.5/9X))
      RETURN
      END

C  ***************************
C  ***************************
C  *** UNTERPROGRAMM SPA93 ***
C  ***************************
C  ***************************
C  DAS UNTERPROGRAMM SPA93 ERMITTELT DIE KRAEFTE UND
C  MOMENTE AN RAEUMLICHEN BALKENELEMENTEN SOWIE DIE
C  LOKALEN VERDREHUNGEN UND DRUCKT SIE
C*******************************************************
C*   VERWENDETE VARIABLEN                              *
C*                                                     *
C*   I1      : ELEMENTNUMMER                           *
C*   E       : ELASTIZITAETSMODUL                      *
C*   AR      : QUERSCHNITTSFLAECHE                     *
C*   Q       : QUERKONTRAKTIONSZAHL                    *
C*   TRZ;TRY : FLAECHENTRAEGHEITSMOMENTE BEZUEGLICH    *
C*             DER LOKALEN ACHSEN                      *
C*   TRTO    : TORSIONSTRAEGHEITSMOMENT                *
C*   XL-ZL   : ACHSENABSCHNITTE                        *
C*   BL      : LAENGE DES BALKENELEMENTES              *
C*                                                     *
C*   VERWENDETE FELDER                                 *
C*                                                     *
C*   X       : KNOTENKOORDINATEN                       *
C*   I4      : BETEILIGTE KNOTENNUMMERN                *
C*   FV      : TEIL DER LOKALEN ES-MATRIX              *
C*   F       : KRAFTVEKTOR                             *
C*   D3      : TRANSFORMATIONSMATRIX                   *
C*   VLOK    : VEKTOR DER LOKALEN VERSCHIEBUNGEN       *
C*******************************************************
      SUBROUTINE SPA93 (I1,I4,X,L1,E,AR,Q,TRZ,TRY,TRTO)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER       FREI, ANZA
      DIMENSION     X(3,3),FV(6,12),F(12),I4(3),D3(3,3),VLOK(12)
      COMMON /FELD/ A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C        INITIALISIEREN
C
      DO   5  J= 1,12
      F(J) = 0.
      VLOK(J)=0.
      DO   5  K= 1, 6
5     FV(K,J)= 0.
C
C        ERMITTELN DER TRANSFORMATIONSMATRIX
C
      XL = X(2,1)-X(1,1)
      YL = X(2,2)-X(1,2)
      ZL = X(2,3)-X(1,3)
C
      BL = (XL**2+YL**2+ZL**2)**0.5
C
      D3(1,1) = XL/BL
      D3(1,2) = YL/BL
      D3(1,3) = ZL/BL
C
      BLS = (D3(1,1)**2+D3(1,2)**2)**0.5
C
C          SONDERFALL BALKEN IN Z- RICHTUNG
C
      IF(BLS.NE.0.) GOTO 10
      D3(2,1)=0.
      D3(2,2)=1.
      GOTO 20
10    D3(2,1) =-D3(1,2)/BLS
      D3(2,2) = D3(1,1)/BLS
20    D3(2,3) = 0.
      D3(3,1) = D3(1,2)*D3(2,3)-D3(1,3)*D3(2,2)
      D3(3,2) = D3(1,3)*D3(2,1)-D3(2,3)*D3(1,1)
      D3(3,3) = D3(1,1)*D3(2,2)-D3(1,2)*D3(2,1)
C
C          ERMITTLUNG DER LOKALEN VERSCHIEBUNGEN
C
      DO  30  K=1,2
      DO  30  L=1,3
      DO  30  M=1,3
      K1 = 3*(K-1)+L
      N1 =(I4(1)-1)*FREI+3*(K-1)+M
      N2 =(I4(2)-1)*FREI+3*(K-1)+M
      VLOK(K1) = VLOK(K1)+D3(L,M)*V(N1)
30    VLOK(K1+6) = VLOK(K1+6)+D3(L,M)*V(N2)
C
      EL = E/BL**2
      GL = E/(2*(1+Q))
C
C       AUFSTELLUNG DER LOKALEN ES-MATRIX
C
      FV( 1, 1) = EL*AR*BL
      FV( 1, 7) =-FV( 1, 1)
      FV( 2, 2) = 12.*EL*TRZ/BL
      FV( 2, 8) =-FV( 2, 2)
      FV( 2, 6) = 6.*EL*TRZ
      FV( 2,12) = FV( 2, 6)
      FV( 6, 2) = FV( 2,12)
      FV( 6, 8) =-FV( 2,12)
      FV( 3, 3) = 12.*EL*TRY/BL
      FV( 3, 9) =-FV( 3, 3)
      FV( 3, 5) =-6.*EL*TRY
      FV( 3,11) = FV( 3, 5)
      FV( 5, 3) = FV( 3, 5)
      FV( 5, 9) =-FV( 3, 5)
      FV( 4, 4) = GL*TRTO/BL
      FV( 4,10) =-FV( 4, 4)
      FV( 5, 5) = 4.*EL*TRY*BL
      FV( 5,11) = FV( 5, 5)/2.
      FV( 6, 6) = 4.*EL*TRZ*BL
      FV( 6,12) = FV( 6, 6)/2.
C
C       ERMITTLUNG DES KRAFTVEKTORS
C
      DO  40  K =1, 6
      DO  40  L =1,12
40    F(K) = F(K)+VLOK(L)*FV(K,L)
C
      DO  50  K =1, 4
50    F(K+6) =-F(K)
C
      F(11) = F(5)-(VLOK(5)*FV(5,5)+VLOK(11)*FV(5,11))
     *            +(VLOK(5)*FV(5,11)+VLOK(11)*FV(5,5))
C
      F(12) = F(6)-(VLOK(6)*FV(6,6)+VLOK(12)*FV(6,12))
     *            +(VLOK(6)*FV(6,12)+VLOK(12)*FV(6,6))
C
C       DRUCKEN DER UEBERSCHRIFT
C
      IF(L1.EQ.1)  WRITE (6,55)
55    FORMAT (26X,'LOKALE KRAEFTE,MOMENTE UND VERDREHUNGEN'//)
C
C       DRUCKEN DES KRAFTVEKTORS UND DER LOKALEN VERDREHUNGEN
C
      WRITE (6,60) I1,I4(1),(F(J),J=1,6),(VLOK(J),J=4,6),
     *             I4(2),(F(K),K=7,12),(VLOK(J),J=10,12)
60    FORMAT (1H ,I5,2(3X,I5,3X,'FLAENGS= ',E11.5,2X,
     *        'FQUERY = ',E11.5,2X,'FQUERZ = ',E11.5/17X,
     *        'MTORS  = ',E11.5,2X,'MBY    = ',E11.5,2X,
     *        'MBZ    = ',E11.5/17X,'WX     = ',E11.5,2X,
     *        'WY     = ',E11.5,2X,'WZ     = ',E11.5//6X))
C
      RETURN
      END

C    *********************************
C    *********************************
C    ***   UNTERPROGRAMM DREI ********
C    *********************************
C    *********************************
C    DAS UNTERPROGRAMM DREIECK ERSTELLT DIE
C    ES-MATRIX FUER DAS STRUKTURELEMENT DREIECK
C    ************************************************
C    *  VERWENDETE VARIABLEN                        *
C    *                                              *
C    *  E     : ELASTIZITAETSMODUL                  *
C    *  Q     : QUERKONTRAKTION                     *
C    *  DI    : DICKE DES DREIECKELEMENTES          *
C    *  AR    : FLAECHENINHALT DES DREIECKELEMENTES *
C    *  DA-DJ : KOORDINATENDIFFERENZEN              *
C    *                                              *
C    *  VERWENDETE FELDER                           *
C    *                                              *
C    *  X     :KNOTENKOORDINATEN                    *
C    *  ELST  :ES-MATRIX                            *
C    ************************************************
      SUBROUTINE DREI (X,DI,E,Q)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER  FREI,ANZA
      DIMENSION  X(3,3)
      COMMON  /ES/  ELST(12,12)
      COMMON  /PAR/ KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      F = (1.-Q)/2.
C
      DA = X(3,2)-X(2,2)
      DB = X(3,1)-X(2,1)
      DC = X(1,2)-X(3,2)
      DD = X(1,1)-X(3,1)
      DE = X(2,2)-X(1,2)
      DF = X(2,1)-X(1,1)
      DG = F*DB
      DH = F*DA
      DJ = F*DC
C
C         BESTIMMUNG DES FLAECHENINHALTES
C
      AR = 0.5*DABS (DF*DA - DB*DE)
C
C         BESTIMMUNG DES SKALARS G
C
      G = (E*DI)/(4.*AR*(1.-Q**2))
C
C         BERECHNUNG DER RECHTEN TEILMATRIX
C
      ELST(1,1) = (DA**2+DG*DB)*G
      ELST(1,2) = -DB*DA*(Q+F)*G
      ELST(1,3) = (DC*DA+DD*DG)*G
      ELST(1,4) = (-Q*DD*DA-DC*DG)*G
      ELST(1,5) = (DA*DE+DG*DF)*G
      ELST(1,6) = (-Q*DF*DA-DE*DG)*G
      ELST(2,2) = (DB**2+DH*DA)*G
      ELST(2,3) = (-Q*DC*DB-DD*DH)*G
      ELST(2,4) = (DB*DD+DH*DC)*G
      ELST(2,5) = (-Q*DE*DB-DF*DH)*G
      ELST(2,6) = (DB*DF+DH*DE)*G
      ELST(3,3) = (DC**2+F*DD**2)*G
      ELST(3,4) = -DD*DC*(Q+F)*G
      ELST(3,5) = (DE*DC+DF*DD*F)*G
      ELST(3,6) = (-Q*DF*DC-F*DE*DD)*G
      ELST(4,4) = (DD**2+DJ*DC)*G
      ELST(4,5) = (-Q*DE*DD-DJ*DF)*G
      ELST(4,6) = (DF*DD+DJ*DE)*G
      ELST(5,5) = (DE**2+F*DF**2)*G
      ELST(5,6) = -DE*DF*(Q+F)*G
      ELST(6,6) = (DF**2+F*DE**2)*G
      RETURN
      END

C    *******************************
C    *******************************
C    ***  UNTERPROGRAMM  BALK2  ****
C    *******************************
C    *******************************
C    DAS UNTERPROGRAMM BALK2 ERSTELLT DIE ES - MATRIX
C    FUER DAS STRUKTURELEMENT  EBENER BALKEN
C    ******************************************************
C    *    VERWENDETE VARIABLEN:                           *
C    *                                                    *
C    *    E     : ELASTIZITAETSMODUL                      *
C    *    AR    : QUERSCHNITTSFLAECHE                     *
C    *    TRZ   : FLAECHENTRAEGHEITSMOMENT BEZUEGLICH     *
C    *               DER LOKALEN Z-ACHSE                  *
C    *    XL;YL : KOORDINATENDIFFERENZEN                  *
C    *    CA;SA : RICHTUNGSCOSINUS ZU DEN GLOBALEN ACHSEN *
C    *                                                    *
C    *    VERWENDETE FELDER:                              *
C    *                                                    *
C    *    X     : KNOTENKOORDINATEN                       *
C    *    ELST  : ES-MATRIX                               *
C    ******************************************************
      SUBROUTINE BALK2 ( X, E , AR , TRZ  )
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER          FREI, ANZA
      DIMENSION        X (3,3)
C
      COMMON  /ES / ELST (12,12)
      COMMON  /PAR/ KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *              LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      XL =   X(2,1)- X(1,1)
      YL =   X(2,2)- X(1,2)
C
C          LAENGE DES BALKENS
C
      STL  = ( XL**2 + YL**2 )**0.5
C
C         BESTIMMUNG DER RICHTUNGSCOSINUS
C
60    CA = XL / STL
      SA = YL / STL
C
80    FO = E * TRZ / STL**3
C
C         KONSTANTEN INNERHALB DER LOKALEN ES-MATRIX
C
      A11 = FO * AR * STL**2 / TRZ
      A22 = FO * 12
      A23 = FO * 6*STL
      A33 = FO * 4*STL**2
C
C         BESTIMMUNG DER ELEMENTE
C
      ELST (1,1) =  (A11*CA**2+A22*SA**2)
      ELST (1,4) = -ELST (1,1)
      ELST (4,4) =  ELST (1,1)
      ELST (1,2) =  CA*SA*( A11-A22 )
      ELST (1,5) = -ELST (1,2)
      ELST (2,4) =  ELST (1,5)
      ELST (4,5) =  ELST (1,2)
      ELST (1,3) = -A23*SA
      ELST (1,6) =  ELST (1,3)
      ELST (3,4) = -ELST (1,3)
      ELST (4,6) =  ELST (3,4)
      ELST (2,2) =  A11*SA**2 + A22*CA**2
      ELST (5,5) =  ELST (2,2)
      ELST (2,5) = -ELST (2,2)
      ELST (2,3) =  A23*CA
      ELST (3,5) = -ELST (2,3)
      ELST (5,6) =  ELST (3,5)
      ELST (2,6) =  ELST (2,3)
      ELST (3,3) =  A33
      ELST (6,6) =  A33
      ELST (3,6) =  A33/2.
C
      RETURN
      END

C  ********************************
C  ********************************
C  ***   UNTERPROGRAMM BALK3    ***
C  ********************************
C  ********************************
C  DAS UNTERPROGRAMM BALK 3  ERSTELLT DIE
C  ES - MATRIX FUER DAS STRUKTURELEMENT
C  RAEUMLICHER BALKEN
C****************************************************
C*                                                  *
C*   VERWENDETE VARIABLEN                           *
C*                                                  *
C*   E      : ELASTIZITAETSMODUL                    *
C*   AR     : QUERSCHNITTSFLAECHE                   *
C*   Q      : QUERKONTRAKTION                       *
C*   TRZ;TRY: FLAECHENTRAEGHEITSMOMENTE BEZUEGLICH  *
C*            DER LOKALEN ACHSEN                    *
C*   TRTO   : TORSIONSTRAEGHEITSMOMENT              *
C*   BL     : LAENGE DES ELEMENTES                  *
C*   XL-ZL  : KOORDINATENDIFFERENZEN                *
C*                                                  *
C*   VERWENDETE FELDER                              *
C*                                                  *
C*   X      : KNOTENKOORDINATEN                     *
C*   D      : TRANSFORMATIONSMATRIX D3              *
C*   DL     : TEILE DER LOKALEN ES-MATRIX           *
C*   ELST   : ES-MATRIX                             *
C****************************************************
      SUBROUTINE  BALK3  (X,E,AR,Q,TRZ,TRY,TRTO)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER             FREI, ANZA
      DIMENSION           X(3,3),D(3,3),DL(3)
C
      COMMON  /ES/   ELST (12,12)
      COMMON  /PAR/  KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
C        KOORDINATENDIFFERENZEN
C
      XL = X(2,1)-X(1,1)
      YL = X(2,2)-X(1,2)
      ZL = X(2,3)-X(1,3)
C
C        BALKENLAENGE
C
      BL = (XL**2+YL**2+ZL**2)**0.5
C
      D(1,1) = XL/BL
      D(1,2) = YL/BL
      D(1,3) = ZL/BL
C
      BLS = (D(1,1)**2+D(1,2)**2)**0.5
C
C         SONDERFALL BALKEN IN Z-RICHTUNG
C
      IF (BLS.NE.0.) GOTO 10
      D(2,1) = 0.
      D(2,2) = 1.
      GOTO 20
10    D(2,1) =-D(1,2)/BLS
      D(2,2) = D(1,1)/BLS
20    D(2,3) = 0.
      D(3,1) = D(1,2)*D(2,3)-D(1,3)*D(2,2)
      D(3,2) = D(1,3)*D(2,1)-D(2,3)*D(1,1)
      D(3,3) = D(1,1)*D(2,2)-D(1,2)*D(2,1)
C
C         ES-MATRIX AUF 0 SETZEN
C
      DO  30  J= 1,12
      DO  30  K= 1,12
30    ELST(J,K)    =0.
C
C         BERECHNUNG DER (3,3)-UNTERMATRIZEN
C         DER GLOBALEN ES-MATRIX
C
      EL=E/BL**2
      DL(1)=E*AR/BL
      DL(2)=12.*EL*TRZ/BL
      DL(3)=12.*EL*TRY/BL
C
      DO  40  K=1,3
      DO  40  L=1,3
      DO  39  M=1,3
39    ELST(K,L)  = ELST(K,L)+D(M,K)*D(M,L)*DL(M)
      ELST(K+6,L+6) = ELST(K,L)
40    ELST(K,L+6)   =-ELST(K,L)
C
      GL=E/(2*(1+Q))
      DL(1)=GL*TRTO/BL
      DL(2)=4.*EL*TRY*BL
      DL(3)=4.*EL*TRZ*BL
C
      DO  50  K=4,6
      DO  50  L=4,6
      DO  49  M=1,3
49    ELST(K,L)  = ELST(K,L)+D(M,K-3)*D(M,L-3)*DL(M)
50    ELST(K+6,L+6) = ELST(K,L)
C
      DL(1)=-DL(1)
      DL(2)= DL(2)/2.
      DL(3)= DL(3)/2.
C
      DO  60  K=4,6
      DO  60  L=10,12
      DO  60  M=1,3
60    ELST(K,L) = ELST(K,L)+D(M,K-3)*D(M,L-9)*DL(M)
C
      DL(2)=-6.*EL*TRY
      DL(3)= 6.*EL*TRZ
C
      DO  70  K=1,3
      DO  70  L=4,6
      ELST(K,L) = ELST(K,L)+D(3,K)*D(2,L-3)*DL(2)
     *                     +D(2,K)*D(3,L-3)*DL(3)
      ELST(K,L+6)   = ELST(K,L)
      ELST(L,K+6)   =-ELST(K,L)
70    ELST(K+6,L+6) =-ELST(K,L)
C
      RETURN
      END

C  *****************************
C  *****************************
C  ***  UNTERPROGRAMM DORG  ****
C  *****************************
C  *****************************
C DAS UP DORG SCHIEBT INNERHALB DES "DREIECKS"
C DIE ZEILEN HOCH UND EINE STELLE NACH LINKS
C
      SUBROUTINE DORG (NZ,N1,N2,ND,LW)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER     FREI,ANZA
      COMMON /FELD/  A(110),D(6105),V(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C         DER PARAMETER LW WIRD BEIM AUFRUF VON CHOLBA AUF
C         1, BEIM AUFRUF VON VORRUE AUF 0 GESETZT
C
C          EINLESEN DER 1. ZEILE AUS '70', WENN NZ=1
C
      IF (NZ.EQ.1) GOTO 444
C
C          HOCHSCHIEBEN DER ZEILEN INNERHALB VON D
C
      DO 333 J = 1,ND
      DO 333 I = 1,J
      K =  J*(J-1)/2 + I
      D(K) = D(K+J+1)
333   CONTINUE
C
C          SICHERN DER IM UP CHOLBA ERSTELLTEN ZEILE
C          DER RECHTSMATRIX ZURUECK IN DIE DATEI '70'
C
      IF (LW.EQ.1) WRITE(70,REC=NZ-1) (D(I), I = N1,N2)
      IF(NZ.EQ.LGS+1) RETURN
444   READ(70,REC=NZ) (D(I) ,I = N1,N2)
      RETURN
      END

C  *****************************
C  *****************************
C  ***  UNTERPROGRAMM RAND  ****
C  *****************************
C  *****************************
C  DAS UP RAND SETZT DIE RANDBEDINGUNGEN IN DIE GS-
C  MATRIX EIN UND RETTET BEI AULA = 'J' DIE UR-
C  SPRUENGLICHE ZEILE DES VOLLSTAENDIGEN BANDES DER
C  GS-MATRIX IN DIE DATEI '80' ZWECKS SPAETERER BE-
C  RECHNUNG DER AUFLAGERREAKTIONEN
C******************************************************
C*    MDA   : LAENGE EINER ZEILE DES VOLLSTAENDIGEN   *
C*            BANDES DER GS-MATRIX                    *
C*    NZEI  : SATZNR. FUER DIE DATEIEN '70' UND '80'  *
C*                                                    *
C*    VERWENDETE FELDER                               *
C*                                                    *
C*    RB    : FELD, IN DEM JEWEILS EINE ZEILE DES     *
C*            VOLLSTAENDIGEN BANDES ERZEUGT WIRD, DIE *
C*            ZU EINER RANDBEDINGUNG GEHOERT          *
C******************************************************
      SUBROUTINE  RAND1 (AULA)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      CHARACTER AULA,NEIN
      CHARACTER*2 NAME , NARA
C
      COMMON /RAND/  KNRA(50),RV(50,6),AUFL(50,6)
      COMMON /FELD/  A(110),D(6105),RB(500),XKN(500)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/  NAME(6) , NARA(50,6)
C
      DATA      NEIN    /'N'/
C
C         LAENGE EINER ABZUSPEICHERNDEN
C         ZEILE DER GS-MATRIX
C
      MDA=MBAND*2-1
C
      OPEN (80,FILE='R',STATUS='NEW',ACCESS='SEQUENTIAL',
     *         FORM='UNFORMATTED')
C
      DO 999   I=1,LRAN
      DO 999   J=1,FREI
      DO 999   K=1,FREI
C
C         SUCHEN EINER RANDBEDINGUNG UND AUS DEREN NAMEN
C         DAS DIAGONALELEMENT DER GS-MATRIX, DEREN SPALTE
C         UND ZEILE IN DIE DATEI '80' GERETTET WERDEN
C
      IF (NARA(I,J).NE.NAME(K))  GOTO 999
      NZEI=(KNRA(I)-1)*FREI+K
      IF (AULA.EQ.NEIN) GOTO 333
C
C           AULA = 'J'
C
      NZEI = NZEI - MBAND
      N = 0
      DO 111 L = 1,MBAND
      NZEI = NZEI + 1
      IF (NZEI.LE.0) GOTO 111
      READ(70,REC=NZEI,ERR=1000) (A(M), M=1,MBAND)
      N = N + 1
      RB(N) = A(MBAND - L + 1)
111   CONTINUE
      DO 222 M = 2,MBAND
      N = N + 1
222   RB(N) = A(M)
      WRITE(80) (RB(M), M=1,MDA)
      GOTO 444
C
C         AULA = 'N'
C
333   READ(70,REC=NZEI,ERR=1000) (A(M), M=1,MBAND)
C
444   A(1) = 1D30
      WRITE(70,REC=NZEI) (A(M), M=1,MBAND)
C
999   CONTINUE
      RETURN
C
1000  WRITE(6,1) KNRA(I)
1     FORMAT(1H0,'MOEGLICHER FEHLER: KNOTENNUMMER',I5,
     *       ' FUER RANDBEDINGUNG FALSCH')
      STOP
C
      END

C  ********************************
C  ********************************
C  ***  UNTERPROGRAMM BELA   ******
C  ********************************
C  ********************************
C  DAS UNTERPROGRAMM BELA BAUT DEN BELASTUNGSVEKTOR
C  DER GESAMTSTEIFIGKEITSBEZIEHUNG AUF
C****************************************************
C*    LF    : BELASTUNGSFALL.                       *
C*    NSOLL : WURDE IM UP EINGAB AUF 1 GESETZT, WENN*
C*            SOLLSCHIEBUNGEN UNGLEICH 0 AUFTRETEN. *
C*    NZEI  : ZEILENNUMMER DER RECHTSMATRIX         *
C*    BEL   : BELASTUNGSVEKTOR                      *
C****************************************************
      SUBROUTINE  BELA1 (LF,NBE,NSOLL)
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
C
      COMMON /FELD/  A(110),D(6105),BEL(500),XKN(500)
      COMMON /BELA/  KNBE(70),NULA(70),BELAST(70,6)
      COMMON /RAND/  KNRA(50),RV(50,6),AUFL(50,6)
      COMMON /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *               LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
      COMMON /CHAR/  NAME(6) , NARA(50,6)
C
      CHARACTER*2 NAME, NARA
C
C         FELD BEL IM BENOETIGTEN BEREICH AUF 0 SETZEN
C
      DO 100  I=1,LGS
100   BEL(I)=0.
C
      DO 600 J=1,NBE
C
C         SUCHEN DER BELASTUNGEN ZUM BELASTUNGSFALL LF
C
      IF (NULA(J).NE.LF)  GOTO 600
      DO 500  I=1,FREI
C
C         ERMITTELN DER ZEILEN DER MATRIX R, DIE ZU DEM
C         LASTKNOTEN GEHOERT
C
      NZEI=(KNBE(J)-1)*FREI+I
C
C         EINTRAGEN DER BELASTUNG IN DIE ENTSPRECHENDE
C         KOMPONENTE DES VEKTORS BEL
C
      BEL(NZEI) = BEL(NZEI) + BELAST(J,I)
500   CONTINUE
600   CONTINUE
C
C        RANDBEDINGUNGEN UNGLEICH 0 UND KRAEFTE
C        IN AUFLAGERN BERABEITEN
C
      DO 4000  I=1,LRAN
      DO 4000  J=1,FREI
      DO 4000  K=1,FREI
      IF (NARA(I,J).NE.NAME(K))  GOTO 4000
      NZEI = (KNRA(I) - 1)*FREI + K
C 
C        IN AUFLAGERN WIRKENDE KRAEFTE RETTEN
C
      AUFL(I,J) = BEL(NZEI)
      IF (NSOLL .EQ. 0) GOTO 4000
C
C     AUFADDIEREN DES WERTES 'SOLLVERSCHIEBUNG*1E30'
C     IN DIE ENTSPRECHENDE KOMPONENTE DES VEKTORS BEL
C
      BEL(NZEI) = BEL(NZEI) + RV(I,J)*1D30
4000  CONTINUE
C
      RETURN
      END
