C  *****************************************
C  *****************************************
C  ***    UNTERPROGRAMM GESAMT       *******
C  *****************************************
C  *****************************************
C  DAS UNTERPROGRAMM GESAMT ERSTELLT DIE RECHTE
C  HAELFTE DES BANDES DER GS-MATRIX
C************************************************************
C*    NZEI  : ZEILE DER GS-MATRIX, DIE BEARBEITET WIRD      *
C*    I1    : ELEMENTNUMMER                                 *
C*    I2    : REFERENZNUMMER DES ELEMENTES                  *
C*    I3    : ANZAHL DER KNOTEN DES ELEMENTES               *
C*    NSPA  : SPALTE DER GS-MATRIX, DIE BEARBEITET WIRD     *
C*    VERWENDETE FELDER                                     *
C*    A     : FELD FUER EINE ZEILE DES BANDES DER GS-MATRIX *
C*    ELST  : FELD FUER DIE ES-MATRIX                       *
C*    I4    : ENTHAELT DIE AN EINEM ELEMENT BETEILIGTEN     *
C*            KNOTENNUMMERN                                 *
C*    X     : KOORDINATEN DER KNOTEN EINES ELEMENTS         *
C************************************************************
      SUBROUTINE  GESAMT
      IMPLICIT REAL*8  (A-H,O-Z)
      INTEGER      FREI,ANZA
      DIMENSION    X(3,3),I4(3)
C
      COMMON  /FELD/  A(110),D(6105),XID(500),XKN(500)
      COMMON  /REFE/  REF(10,7)
      COMMON  /ES/    ELST (12,12)
      COMMON  /PAR/   KOANZ,FREI,ANZA,ETYP(2),MBAND,LELE,
     *                LREF,LRAN,KGRNR,LGS,LAD,LAV,LAX
C
      OPEN (70,FILE='G',STATUS='NEW',ACCESS='DIRECT'
     *        ,RECL=8*MBAND,FORM='UNFORMATTED')
C
C         DATEI '52' AUF DEN ANFANG SETZEN
C
      REWIND 52
C       
C       FELD XID DIENT ZUR KENNZEICHNUNG,
C       OB EIN SATZ AUS '70' ERSTMALIG GELESEN WIRD
C
      DO 1000 M = 1 , LGS
1000  XID(M) = 0.
      DO 8000  LL=1,LELE
C
C         EINLESEN EINER ZEILE AUS ELEM
C
      READ (52)  I1,I2,I3,(I4(M),M=1,I3)
C
C         SUCHEN DER KNOTENKOORDINATEN IM FELD XKN
C
      DO 2000  M=1,I3
      NA = (I4(M)-1)*KOANZ
      IF(I4(M).GT.KGRNR) GOTO 9000
      DO 2000 J = 1,KOANZ
      X(M,J) = XKN(NA+J)
2000  CONTINUE
C
C        AUFRUF EINES UP'S ZUM ERSTELLEN DER
C        ES-MATRIX JE NACH ELEMENTTYP
C
      IF(REF(I2,1).NE.4.) GOTO 3110
      CALL STAB (X,REF(I2,2),REF(I2,3))
      GOTO 3200
3110  IF(REF(I2,1).NE.1.) GOTO 3120
      CALL DREI (X,REF(I2,2),REF(I2,3),REF(I2,4))
      GOTO 3200
3120  IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.3)) GOTO 3130
      CALL BALK2(X,REF(I2,2),REF(I2,3),REF(I2,4))
      GOTO 3200
3130  IF(.NOT.(REF(I2,1).EQ.9..AND.FREI.EQ.6)) GOTO 3140
      CALL BALK3(X,REF(I2,2),REF(I2,3),REF(I2,4)
     *  ,REF(I2,5),REF(I2,6),REF(I2,7))
      GOTO 3200
3140    WRITE (6,10) REF(I2,1)
10      FORMAT (1H0 ,'ELEMENTTYP ',F5.2,' NICHT VORHANDEN')
        STOP
C
3200  N = 0
      DO 8000  II=1,I3
      DO 8000  I=1,FREI
C
      N = N + 1
C
C         ZEILENNUMMER DER GS-MATRIX, AUF DIE EINE
C         ZEILE DER ES-MATRIX AUFADDIERT WIRD
C
      NZEI = (I4(II) - 1)*FREI + I
C
C          LESEN DER ZEILE DER GS-MATRIX AUS DER DATEI '70'
C
      IF (XID(NZEI) .GT. 0.) THEN
        READ (70,REC=NZEI) (A(L),L=1,MBAND)
      ELSE
C
C         A WIRD AUF 0 INITIALISIERT,WENN DIE EINZULESENDE
C         ZEILE AUF DATEI '70' NOCH NICHT VORHANDEN WAR
C
        DO 4600  L=1,MBAND
4600    A(L)=0.
      ENDIF
C
C         ERMITTELN DER SPALTE UND PRUEFEN, OB DAS
C         ELEMENT DER ES-MATRIX IM BAND LIEGT, ANDERNFALLS
C         SPRUNG ZUR ERMITTLUNG DER NAECHSTEN SPALTE
C
5000  M = 0
      DO 6000  JJ=1,I3
      DO 6000  J=1,FREI
      M = M + 1
      NSPA =(I4(JJ)-1)*FREI+J
      IF (NSPA.LT.NZEI) GOTO 6000
C
C         ERMITTLUNG DES INDEX L DER A-ZEILE
C
      L= NSPA - NZEI + 1
      IF (M .GT. N) GOTO 5500
      A(L) = A(L) + ELST(M,N)
      GOTO 6000
5500  A(L) = A(L) +  ELST(N,M)
6000  XID(NZEI) = 1.
C
C        ZURUECKSCHREIBEN DER ZEILE IN DIE DATEI '70'
C
      WRITE (70,REC=NZEI)  (A(K),K=1,MBAND)
8000  CONTINUE
      RETURN
9000  WRITE (6,1) I4(M)
1     FORMAT(1H ,'ENDE DES FELDES XKN GEFUNDEN '/
     *           'MOEGLICHER FEHLER: KNOTEN ',I5,' FEHLT')
      STOP
      END
