      PROGRAM PLATTE
C
C      Vereinbarungsteil
C
      INTEGER REF(705),ANZRA,ANZREF,IRA,HREF,KND(705),KNDMAX,MB,
     * KNEL(705,2),KNRA(50),KNDR(6),I4(2),KN,KNANZ,KN0,IKO,
     * ELKN(256,10),E(4),ANZ(256),I1,Z(2),EL0,IEL,
     * K,R,T,S1,S3,I,J,N,PEND,IKSUM,IESUM,KGRNR,EGRNR,
     * ID,ID1,ID2,ID3,KN1(450),KN2(450),KN3(450),KONTR,KONTR1,KONTR2
      REAL AGRENZ,AGR,AKL,ELART,EMOD,F,F1,F2,TOL,
     * X(256),Y(256),L(5),A(705),ARK(20),S(2),
     * DI(450),H,H1,H2,FAK
      CHARACTER*1 STERN,IST,VAR,DIV,PLA,DIK,KEY,KON,AUS
      CHARACTER*2 NARA(50,2)
      CHARACTER*4 KOOR,ELEM,REFE,RAND,ENDE,TEXT
      CHARACTER*12 STRUKDAT
      DATA KOOR,ELEM,REFE,RAND,STERN,ENDE
     * /'KOOR','ELEM','REFE','RAND','*','ENDE'/
      DATA IESUM,IKSUM,KGRNR,EGRNR,IKO,IEL,IRA,KN0,EL0,PEND,ID
     * /11*0/
      OPEN (1,FILE='CON')
      OPEN (10,FILE='DREIECK')
C
C      Kurzerlaeuterungen fuer den Anwender
C
      PRINT*
      WRITE (1,500)
500   FORMAT (12X,'KURZBESCHREIBUNG DES PROGRAMMS PLATTE'/
     * 12X,37(1H=),/
     *' Dieses  Programm  berechnet  die  Stabflaechen  eines Finite-'/
     *' Elemente-Stabfachwerks, wenn  eine  ebene Plattenkonstruktion'/
     *' durch  Staebe  angenaehert  werden soll, und vervollstaendigt'/
     *' die Strukturdatei hinsichtlich der Referenznummern.'/
     *' Vorraussetzung ist, dass ausser den Pendelstaeben alle Staebe'/
     *' Dreiecke bilden. Ueberschneidungen sind nicht erlaubt.'/
     *' Als  Eingabedatei  wird eine Strukturdatei, wie sie auch fuer'/
     *' das Gawehn-Finite-Elemente-Programm benoetigt wird,verwendet.'/
     *' Es  werden  die  Datenbloecke  KOOR,ELEM und RAND  benoetigt.'/
     *' Die anderen Datenbloecke  REFE und BELA  sind nicht erforder-'/
     *' lich, koennen aber enthalten sein.'/
     *' Das  Berechnungsprinzip besteht darin,dass das von drei Stae-'/
     *' ben  begrenzte  Dreiecksvolumen wahlweise durch den Dreiecks-'/
     *' umfang  oder die Laenge des betrachteten Stabes geteilt wird.'/
     *' Im  Falle  eines Randstabes ist das angrenzende Dreieck mass-'/
     *' gebend; im  Falle  eines  in der Mitte der Struktur liegenden'/
     *' Stabes  ergibt  sich  seine Querschnittsflaeche aus der Summe'/
     *' der Ergebnisse beider angrenzender Dreiecke.Die Flaeche eines'/
     *' Pendelstabes muss per Hand eingegeben werden.')
      PRINT*,' Weiter mit RETURN !'
      READ (1,'(A1)') KEY
      WRITE (1,510)
510   FORMAT (/,' Das Programm bietet folgende Wahlmoeglichkeiten:'//
     *' 1. Wahlweise Berechnung mit oder ohne Kontrollausgaben;'/
     *' 2. Wahl zwischen konstanter oder variabler Plattendicke;'/
     *' 3. Die Dicken der Dreiecksflaechen koennen entweder von Hand'/
     *'     eingegeben oder aus einer Datei eingelesen werden;'/
     *' 4. Wahl eines Faktors zur Vergroesserung der Stabflaechen;'/
     *' 5. Wahl der Anzahl der Referenzen ( Stabflaechen );'/
     *' 6. Division des Dreiecksvolumen durch den Umfang des Dreiecks'/
     *'     oder die Stablaenge;'/
     *' 7. Wahlweise Ausgabe der Ergebnisse auf Bildschirm oder'/
     *'     Drucker;'/
     *' 8. Den Pendelstaeben wird entweder die hoechste oder eine'/
     *'     vom Programm zu berechnende Referenznummer zugeordnet.')
      PRINT*,' Weiter mit RETURN = Beginn des Programmablaufs !'
      READ (1,'(A1)') KEY
C
C      Eingabe der Variablen
C
      PRINT*
      WRITE (1,*)' Bitte Namen der Strukturdatei eingeben:'
      READ (1,1) STRUKDAT
1     FORMAT (A12)
110   OPEN (50,FILE=STRUKDAT)
C
111   WRITE (1,112)
112   FORMAT (1H ,'Berechnung mit oder ohne Kontrollausgaben (m/o) ?')
      READ (1,6) KON
      IF (KON.NE.'m'.AND.KON.NE.'o') GOTO 111
C
113   WRITE( 1,*)' Konstante (k) oder variable (v) Plattendicke ?'
      READ (1,6) PLA
      IF (PLA.EQ.'k') GOTO 114
      IF (PLA.EQ.'v') GOTO 115
      GOTO 113
C
114   WRITE (1,*)' Bitte Dicke der Platte (in mm) eingeben:'
      READ (1,2) H
2     FORMAT (F10.0)
      IF (KON.EQ.'o') GOTO 122
      WRITE (1,3) H
3     FORMAT (1H ,'Plattendicke = ',F10.2)
      GOTO 122
C
115   WRITE (1,116)
116   FORMAT(' Eingabe der Dicken der Dreiecke per Hand (e)'/
     *' oder Einlesen aus der Datei "DREIECK" (d) ?')
      READ (1,6) DIK
      IF (DIK.NE.'e'.AND.DIK.NE.'d') GOTO 115
C
122   WRITE (1,123)
123   FORMAT (' Bitte Eingabe des Multiplikationsfaktors fuer'/
     *' die Stabflaechen:')
      READ (1,2) FAK
      IF (FAK.LE.0.) GOTO 122
C
117   WRITE (1,*)' Bitte Anzahl der Referenzen (bis 20) eingeben:'
      READ (1,4) ANZREF
4     FORMAT (I2)
      IF (ANZREF.GT.20.OR.ANZREF.LE.0) GOTO 117
      IF (KON.EQ.'o') GOTO 119
      WRITE (1,118) ANZREF
118   FORMAT (1H ,'Anzahl der Referenzen = ',I2)
C
119   WRITE (1,5)
5     FORMAT (1H ,'Division des Dreieckvolumens durch die'/
     *' Stablaenge (l) oder durch den Dreiecksumfang (u) ?')
      READ (1,6) DIV
6     FORMAT (A1)
      IF (DIV.EQ.'l'.OR.DIV.EQ.'u') GOTO 120
      GOTO 119
C
120   IF (KON.EQ.'o'.AND.PLA.EQ.'k'.OR.KON.EQ.'o'.AND.DIK.EQ.'d')
     * GOTO 100
      WRITE (1,121)
121   FORMAT (1H ,'Ausgabe der Ergebnisse auf Bildschirm (b) oder'/
     *' Drucker (d) ?')
      READ (1,6) AUS
      IF (AUS.NE.'b'.AND.AUS.NE.'d') GOTO 120
      IF (AUS.EQ.'b') THEN
      OPEN (3,FILE='CON')
      ELSE
      OPEN (3,FILE='LPT1')
      END IF
C
C      Einlesen der Strukturdatei und Verzweigung
C
100   READ (50,7,END=400)TEXT
7     FORMAT (A4)
      IF (TEXT.EQ.KOOR) GOTO 1000
      IF (TEXT.EQ.ELEM) GOTO 2000
      IF (TEXT.EQ.RAND) GOTO 3000
      IF (TEXT.EQ.ENDE) GOTO 200
      GOTO 100
200   IF (IKO*IEL*IRA.EQ.0) GOTO 300
C     
C      Verzweigung zur Berechnung der Stabflaechen
C
      GOTO 4000
C
C      Fehlermeldungen
C
300   WRITE (1,8)
8     FORMAT (1H ,'FEHLER: Datenblock oder Datenblockname KOOR,ELEM'/
     *' oder RAND fehlt oder ist falsch !')
      STOP 8
400   WRITE (1,9)
9     FORMAT (1H ,'FEHLER: ENDE-Parameter in Strukturdatei fehlt,'/
     *' oder ein falscher Dateiname wurde verwendet !')
      STOP 9
C
C     *********************************
C     *        Datenblock KOOR        *
C     *********************************
C
1000  WRITE (1,'(1H ,''KOOR'')')
      IKO=1
C
C      Einlesen der Knotennummern und der Koordinaten
C
      J=0
1100  READ (50,10) IST,KN,(S(J),J=1,2)
10    FORMAT (A1,I4,5X,2F10.0)
C
C      Pruefen auf durchlaufende Numerierung
C
      IF (KN-KN0.EQ.1) GOTO 1300
      WRITE (1,12) KN
12    FORMAT (1H ,'Fehler bei Knoten Nummer ',I4,' !')
      STOP 12
1300  KN0=KN
C
C      Feststellen der bisher groessten Knotennummer
C
      IF (KN.GT.KGRNR) KGRNR=KN
C
C      Berechnung der Summe der Knotennummern
C
      IKSUM=IKSUM+KN
C
C      Pruefen der Anzahl der Knoten
C
      J=J+1
      IF (J.LE.256) GOTO 1400
      WRITE (1,13)
13    FORMAT (1H ,'FEHLER: Mehr als 256 Knoten vorhanden !')
      STOP 13
C
C      Eintragen der Koordinaten in die Felder X und Y
C
1400  X(KN)=S(1)
      Y(KN)=S(2)
C
C      Pruefen auf letzte Zeile im Datenblock
C
      IF (IST.EQ.' ') GOTO 1100
      WRITE (1,14)KGRNR
14    FORMAT (1H ,'Groesste Knotennummer: ',I4)
C
C      Vergleich theoretischer mit tatsaechlicher Summe
C
      K=KGRNR*(KGRNR+1)/2
      IF (IKSUM.EQ.K) GOTO 100
      WRITE (1,15)
15    FORMAT (1H ,'Fehler in der Knotennumerierung !')
      STOP 15
C
C     *********************************
C     *        Datenblock ELEM        *
C     *********************************
C
2000  WRITE (1,'(1H ,''ELEM'')')
      IEL=1
C
C      Einlesen der Elementnummern und der Knotennummern
C
      J=0
      KNDMAX=0
2100  READ (50,20) IST,I1,(I4(M),M=1,2)
20    FORMAT (A1,I4,10X,2I5)
C
C      Pruefen auf durchlaufende Numerierung
C
      IF (I1-EL0.EQ.1) GOTO 2300
      WRITE (1,22) I1
22    FORMAT (1H ,'Fehler bei Element Nummer ',I4,' !')
      STOP 22
2300  EL0=I1
C
C      Feststellen der bisher groessten Elementnummer
C
      IF (I1.GT.EGRNR) EGRNR=I1
C
C      Berechnung der Summe der Elementnummern
C
      IESUM=IESUM+I1
C
C      Pruefen der Knoten des Elementes
C
      IF (I4(2).GT.I4(1)) GOTO 2400
      WRITE (1,23) I1
23    FORMAT (1H ,'FEHLER: Beim Element Nr. ',I4,' ist der erste'/
     *' Knoten groesser als der oder gleich dem zweiten Knoten !')
      STOP 23
C
2400  IF (I4(1).LE.KGRNR.AND.I4(2).LE.KGRNR) GOTO 2450
      WRITE (1,24) I1
24    FORMAT (1H ,'FEHLER: Beim Element Nr. ',I4,' ist eine Knoten-'/
     *' Nr. groesser als die groesste eingelesene Knotennummer;'/
     *' oder die Datenbloecke KOOR,ELEM und RAND sind vertauscht!')
      STOP 24
C
C      maximale Knotennummerdifferenz
C
2450  KND(I1)=I4(2)-I4(1)
      IF (KND(I1).GT.KNDMAX) KNDMAX=KND(I1)
      IF (KNDMAX.LE.54) GOTO 2500
      WRITE (1,16) I1,I4(1),I4(2)
16    FORMAT (1H ,'FEHLER: Beim Element Nr. ',I4,'(Knoten:',2I5,')'/
     *' ist die Knotennummerdifferenz groesser als 54 !')
C
C      Pruefen der Anzahl der Elemente
C
2500  J=J+1
      IF (J.LE.705) GOTO 2600
      WRITE (1,25)
25    FORMAT (1H ,'FEHLER: Mehr als 705 Elemente vorhanden !')
      STOP 25
C
C      Eintragen der Element-Knoten-Zuordnung in das Feld KNEL
C
2600  KNEL(I1,1)=I4(1)
      KNEL(I1,2)=I4(2)
C
C      Prfen auf letzte Zeile im Datenblock
C
      IF (IST.EQ.' ') GOTO 2100
      WRITE (1,26) EGRNR
26    FORMAT (1H ,'Groesste Elementnummer: ',I4)
C
C      Ausgabe der Elemente mit der groessten Kn.-Nr.-Differenz
C
      PRINT*
      MB=(KNDMAX+1)*2
      WRITE (1,17) KNDMAX,MB
17    FORMAT (' maximale Knotennummerdifferenz = ',I4,/
     *' Strukturbandweite = ',I4)
      WRITE (1,18)
18    FORMAT (' Elemente mit der maximalen Knoten-Nr.-Diff.:')
      DO 2700 I1=1,EGRNR
      IF (KND(I1).LT.KNDMAX) GOTO 2700
      WRITE (1,19) I1,KNEL(I1,1),KNEL(I1,2)
19    FORMAT (' Element :',I4,'    Knoten : ',2I5)
2700  CONTINUE
      PRINT*
C
C      Vergleich theoretischer mit tatsaechlicher Summe
C
2800  K=EGRNR*(EGRNR+1)/2
      IF (IESUM.EQ.K) GOTO 100
      WRITE (1,27)
27    FORMAT (1H ,'Fehler in der Elementnumerierung !')
      STOP 27
C
C     *********************************
C     *        Datenblock RAND        *
C     *********************************
C
3000  WRITE (1,'(1H ,''RAND'')')
      IRA=1
C
C      Einlesen der Knoten mit den Randbedingungen
C
      J=1
3100  READ (50,30) IST,KNRA(J),(NARA(J,M),M=1,2)
30    FORMAT (A1,I4,5X,A2,18X,A2)
C
C      Pruefen der Anzahl der Knoten mit Randbedingungen
C
3200  J=J+1
      ANZRA=J-1
      IF (ANZRA.LE.50) GOTO 3300
      WRITE (1,32)
32    FORMAT (1H ,'FEHLER: Mehr als 50 Knoten'/
     *' mit Randbedingungen vorhanden !')
      STOP 32
C
C      Pruefen auf letzte Zeile im Datenblock
C
3300  IF (IST.EQ.' ') GOTO 3100
      GOTO 100
C
C     ********************************************
C     *  Erstellen der Knoten-Element-Zuordnung  *
C     *     aus der Element-Knoten-Zuordnung     *
C     ********************************************
C
4000  WRITE (1,'(1H ,''Knoten-Element-Zuordnung'')')
      PRINT*
C
C      Schleife ueber alle Knoten
C
      DO 4300 KN=1,KGRNR
      J=0
C
C      Suche nach allen Staeben,die einen Knoten gemeinsam haben
C
      DO 4100 I1=1,EGRNR
      DO 4100 M=1,2
      IF (KNEL(I1,M).NE.KN) GOTO 4100
      J=J+1
      ELKN(KN,J)=I1
4100  CONTINUE
C
C      Anzeige der Anzahl Staebe pro Knoten
C
      ANZ(KN)=J
      IF (KON.EQ.'o') GOTO 4250
C
      IF (ANZ(KN).GT.1) GOTO 4200
      WRITE (3,40) KN
40    FORMAT (' Am Knoten Nr. ',I4,' greift   1 Stab   an')
      IF (PLA.EQ.'k'.OR.DIK.EQ.'d'.OR.AUS.EQ.'b') GOTO 4300
      WRITE (1,40) KN
      GOTO 4300
C
4200  WRITE (3,42) KN,ANZ(KN)
42    FORMAT (' Am Knoten Nr. ',I4,' greifen ',I2,' Staebe an')
      IF (PLA.EQ.'k'.OR.DIK.EQ.'d'.OR.AUS.EQ.'b') GOTO 4250
      WRITE (1,42) KN,ANZ(KN)
C
4250  IF (ANZ(KN).GT.10) GOTO 4400
4300  CONTINUE
      GOTO 6000
C
C      Fehlermeldung
C
4400  WRITE (1,44) KN
44    FORMAT (1H ,'FEHLER: Am Knoten Nr. ',I4,' greifen'/
     *' mehr als 10 Staebe an !')
      STOP 44
C
C     *******************************************
C     *         Suche nach den Dreiecken        *
C     *     und Berechnung der Stabflaechen     *
C     *******************************************
C
6000  PRINT*
      WRITE (1,'(1H ,''Berechnen der Stabflaechen'')')
      PRINT*
C
C     **********************************
C     *   Schleife ueber alle Staebe   *
C     **********************************
C
      DO 7900 I1=1,EGRNR
C
C      Bestimmung der Stabpaare
C
      N=0
      DO 6400 I=1,ANZ(KNEL(I1,1))
      DO 6400 J=1,ANZ(KNEL(I1,2))
C
      IF (KNEL(I1,1).EQ.KNEL(ELKN(KNEL(I1,1),I),1)) R=2
      IF (KNEL(I1,1).EQ.KNEL(ELKN(KNEL(I1,1),I),2)) R=1
      IF (KNEL(I1,2).EQ.KNEL(ELKN(KNEL(I1,2),J),1)) T=2
      IF (KNEL(I1,2).EQ.KNEL(ELKN(KNEL(I1,2),J),2)) T=1
      IF (KNEL(ELKN(KNEL(I1,1),I),R).NE.KNEL(ELKN(KNEL(I1,2),J),T))
     * GOTO 6400
C
C      Zuordnung der Stabpaare
C
      N=N+1
      IF (N.GE.3) GOTO 6400
      IF (N.EQ.2) GOTO 6300
      E(1)=ELKN(KNEL(I1,1),I)
      E(2)=ELKN(KNEL(I1,2),J)
      IF (N.EQ.1) GOTO 6400
6300  E(3)=ELKN(KNEL(I1,1),I)
      E(4)=ELKN(KNEL(I1,2),J)
C
6400  CONTINUE
C
      IF (KON.EQ.'o'.AND.DIK.EQ.'d'.OR.KON.EQ.'o'.AND.PLA.EQ.'k')
     * GOTO 6500
      WRITE (3,61)
61    FORMAT (' ')
      IF (N.EQ.0) THEN
      WRITE (3,60) I1,N
60    FORMAT ('Der Stab',I4,' ist ein Pendelstab (',I2,' Dreiecke )')
      ELSE IF (N.EQ.1) THEN
      WRITE (3,62) I1,N
62    FORMAT ('Der Stab',I4,' ist von ',I2,' Dreieck umgeben')
      ELSE IF (N.GE.2) THEN
      WRITE (3,64) I1,N
64    FORMAT ('Der Stab',I4,' ist von ',I2,' Dreiecken umgeben')
      END IF
C
      IF (PLA.EQ.'k'.OR.DIK.EQ.'d'.OR.AUS.EQ.'b') GOTO 6500
      WRITE (1,61)
      IF (N.EQ.0) THEN
      WRITE (1,60) I1,N
      ELSE IF (N.EQ.1) THEN
      WRITE (1,62) I1,N
      ELSE IF (N.GE.2) THEN
      WRITE (1,64) I1,N
      END IF
C
C      Verzweigung je nach Anzahl N der Stabpaare bzw. Dreiecke
C
6500  IF (N.EQ.0) GOTO 7100
      IF (N.EQ.1) GOTO 7200
      IF (N.EQ.2) GOTO 7300
C
C      Fehlermeldung
C
      WRITE (1,66) I1
66    FORMAT (1H ,'FEHLER: In der Umgebung von Stab Nr. ',I4/
     *' ueberkreuzen sich zwei Staebe !')
      STOP 66
C
C     *********************************************
C     *              Kein  Stabpaar,              *
C     *           d.h. einzelne Staebe            *
C     * Jeder  Knoten dieses Stabes muss entweder *
C     * ein Knoten mit zwei Randbedingungen sein, *
C     * oder an ihm muessen mindestens zwei ande- *
C     * re Staebe angreifen !                     *
C     ********************************************* 
C
C      Suche nach Randbedingungen an den Knoten des Stabes I1
C
7100  PEND=PEND+1
      DO 7140 M=1,2
      DO 7120 J=1,ANZRA
      IF (KNEL(I1,M).NE.KNRA(J)) GOTO 7120
      IF (NARA(J,1).NE.' '.AND.NARA(J,2).NE.' ') THEN
      Z(M)=2
      GOTO 7140
      ELSE
      GOTO 7120
      END IF
7120  CONTINUE
C
C      Abfrage der Anzahl der Staebe am Knoten M des Stabes I1
C
      IF (ANZ(KNEL(I1,M)).GE.2) Z(M)=2
7140  CONTINUE
C
C      Fuer den Fall,dass dieser Stab ein stabil gelagerter Stab
C      ist, muss seine Flaeche ( in mm**2 ) per Hand  eingegeben
C      werden;dann muss gewaehlt werden,ob er die groesste Refe-
C      renznummer erhalten soll ( dann werden die uebrigen Refe-
C      renznummern auf die anderen Staebe verteilt ) oder ob das
C      Programm  diese Referenznummer an Hand der Flaeche selber
C      berechnen  soll ( dann  werden  die  Referenznummern  auf
C      alle Staebe verteilt ).
C
      IF (Z(1).EQ.2.AND.Z(2).EQ.2) GOTO 7160
      WRITE (1,70) I1
70    FORMAT (1H ,'FEHLER: Der Stab Nr. ',I4,' ist labil, d.h.'/
     *' er ist nicht ausreichend in die Struktur eingebunden !')
      STOP 70
C
7160  IF (PEND.GE.2) GOTO 7180
C
7170  WRITE (1,71)
71    FORMAT (1H ,'Sollen die Pendelstaebe die hoechste (h) oder eine'/
     *' vom Programm zu berechnende (b) Referenznummer erhalten ?')
      READ (1,72) VAR
72    FORMAT (A1)
C
      IF (VAR.EQ.'h') THEN
      WRITE (1,73)
73    FORMAT (1H ,'Bitte Flaeche der Pendelstaebe eingeben:')
      READ (1,74) A(I1)
74    FORMAT (F10.0)
      REF(I1)=ANZREF
      ARK(ANZREF)=A(I1)
      HREF=ANZREF-1
C
      ELSE IF (VAR.EQ.'b') THEN
      WRITE (1,710) I1
710   FORMAT (1H ,'Bitte Flaeche des Pendelstabes ',I4,' eingeben:')
      READ (1,74) A(I1)
      HREF=ANZREF
C
      ELSE
      GOTO 7170
      END IF
      GOTO 7190
C
7180  IF (VAR.EQ.'h') THEN
      A(I1)=ARK(ANZREF)
      REF(I1)=ANZREF
      ELSE
      WRITE (1,710) I1
      READ (1,74) A(I1)
      END IF
C
7190  IF (KON.EQ.'o') GOTO 7800
      L(I1)=SQRT ( ( X(KNEL(I1,2)) - X(KNEL(I1,1)) )**2
     *            +( Y(KNEL(I1,2)) - Y(KNEL(I1,1)) )**2 )    
      WRITE (3,76) I1,A(I1)
76    FORMAT (' Der Stab ',I4,' hat die Flaeche ',F12.3)
      WRITE (3,77) I1,L(I1)
77    FORMAT (' Der Stab ',I4,' hat die Laenge  ',F12.3)
      GOTO 7800
C
C     ********************************************
C     *            Ein Stabpaar, d.h.            *
C     *   der Stab liegt am Rande der Struktur   *
C     ********************************************
C
C      Knotennummern des Dreiecks
C
7200  IF (KNEL(E(1),1).EQ.KNEL(I1,1)) R=2
      IF (KNEL(E(1),2).EQ.KNEL(I1,1)) R=1
      IF (KNEL(E(1),R).LT.KNEL(I1,1)) THEN
      KNDR(1)=KNEL(E(1),R)
      KNDR(2)=KNEL(I1,1)
      KNDR(3)=KNEL(I1,2)
      ELSE IF (KNEL(E(1),R).LT.KNEL(I1,2)) THEN
      KNDR(1)=KNEL(I1,1)
      KNDR(2)=KNEL(E(1),R)
      KNDR(3)=KNEL(I1,2)
      ELSE
      KNDR(1)=KNEL(I1,1)
      KNDR(2)=KNEL(I1,2)
      KNDR(3)=KNEL(E(1),R)
      END IF
      IF (PLA.EQ.'k') GOTO 7270
C
C      Ermittlung des Index ID des Dreiecks.
C      ID wird nur dann um 1 erhoeht, wenn das Dreieck mit denselben
C      Knoten nicht schon vorher vorgekommen ist.
C
      KONTR=0
      IF (ID.EQ.0) GOTO 7230
      DO 7220 J=1,ID
      IF (KN1(J).EQ.KNDR(1).AND.KN2(J).EQ.KNDR(2).AND.KN3(J).EQ.KNDR(3))
     * THEN
      KONTR=1
      ID3=J
      GOTO 7235
      ELSE
      GOTO 7220
      END IF
7220  CONTINUE
7230  IF (KONTR.EQ.0) ID=ID+1
      KN1(ID)=KNDR(1)
      KN2(ID)=KNDR(2)
      KN3(ID)=KNDR(3)
      ID3=ID
C
C      Lesen der Dreiecksdicke aus der Datei "DREIECK"
C
7235  IF (DIK.EQ.'e') GOTO 7240
      IF (KONTR.EQ.1) THEN
      H=DI(ID3)
      GOTO 7240
      ELSE
      READ (10,720) ID3,DI(ID3)
720   FORMAT (1X,I4,5X,F10.3)
      H=DI(ID3)
      GOTO 7240
      END IF
C
C      Eingabe der variablen Plattendicke.
C      Nach  der  Angabe  des Dreiecks wird durch Betaetigung der
C      Return-Taste der Wert des vorherigen Dreiecks uebernommen.
C     
7240  IF (KON.EQ.'o'.AND.DIK.EQ.'d') GOTO 7270
      WRITE (3,721) ID3,KN1(ID3),KN2(ID3),KN3(ID3)
721   FORMAT (' Die Knoten des Dreiecks ',I4,' sind: ',3(1X,I4))
      IF (DIK.EQ.'d') GOTO 7260
      IF (AUS.EQ.'b') GOTO 7250
      WRITE (1,721) ID3,KN1(ID3),KN2(ID3),KN3(ID3)
7250  IF (KONTR.EQ.1) GOTO 7260
      WRITE (1,722) H
722   FORMAT (' Dicke des Dreiecks (',F10.3,'):')
      READ (1,723) DI(ID3)
723   FORMAT (F10.0)
      IF (DI(ID3).EQ.0.) DI(ID3)=H
7260  H=DI(ID3)
      WRITE (3,724) H
724   FORMAT (' Dicke = ',F10.3)
      IF (DIK.EQ.'d') GOTO 7270
      IF (AUS.EQ.'b') GOTO 7265
      WRITE (1,724) H
7265  IF (KONTR.EQ.1) GOTO 7270
      WRITE (10,725) ID3,DI(ID3),KN1(ID3),KN2(ID3),KN3(ID3)
725   FORMAT (1X,I4,5X,F10.3,3I5)
C
C      Flaeche F des Dreiecks
C
7270  F=0.5*ABS ( X(KNDR(1)) * ( Y(KNDR(2)) - Y(KNDR(3)) )
     *          + X(KNDR(2)) * ( Y(KNDR(3)) - Y(KNDR(1)) )
     *          + X(KNDR(3)) * ( Y(KNDR(1)) - Y(KNDR(2)) ) )
C
C      Berechnung der Stablaengen mit:
C
C      L(1)=L(I1); L(2)=L(E(1)); L(3)=L(E(2))
C
      L(1)=SQRT ( ( X(KNEL(I1,2)) - X(KNEL(I1,1)) )**2
     *           +( Y(KNEL(I1,2)) - Y(KNEL(I1,1)) )**2 )    
      L(2)=SQRT ( ( X(KNEL(E(1),2)) - X(KNEL(E(1),1)) )**2
     *           +( Y(KNEL(E(1),2)) - Y(KNEL(E(1),1)) )**2 )    
      L(3)=SQRT ( ( X(KNEL(E(2),2)) - X(KNEL(E(2),1)) )**2
     *           +( Y(KNEL(E(2),2)) - Y(KNEL(E(2),1)) )**2 )    
C
C      Querschnittsflaeche des Stabes
C
      IF (DIV.EQ.'l') GOTO 7280
      A(I1) = FAK * F*H / ( L(1) + L(2) + L(3) )
      GOTO 7290
7280  A(I1) = FAK * F*H / L(1)
C
C      Kontrollausgaben
C
7290  IF (KON.EQ.'o') GOTO 7800
      WRITE (3,76) I1,A(I1)
      WRITE (3,77) I1,L(1)
      IF (PLA.EQ.'k'.OR.DIK.EQ.'d'.OR.DIK.EQ.'e'.AND.AUS.EQ.'b')
     * GOTO 7800
      WRITE (1,76) I1,A(I1)
      WRITE (1,77) I1,L(1)
      GOTO 7800
C
C     ********************************************
C     *           Zwei Stabpaare, d.h.           *
C     * der Stab liegt in der Mitte der Struktur *
C     ********************************************
C
C      Knotennummern des 1.Dreiecks
C
7300  IF (KNEL(I1,1).EQ.KNEL(E(1),1)) S1=2
      IF (KNEL(I1,1).EQ.KNEL(E(1),2)) S1=1
      IF (KNEL(E(1),S1).LT.KNEL(I1,1)) THEN
      KNDR(1)=KNEL(E(1),S1)
      KNDR(2)=KNEL(I1,1)
      KNDR(3)=KNEL(I1,2)
      ELSE IF (KNEL(E(1),S1).LT.KNEL(I1,2)) THEN
      KNDR(1)=KNEL(I1,1)
      KNDR(2)=KNEL(E(1),S1)
      KNDR(3)=KNEL(I1,2)
      ELSE
      KNDR(1)=KNEL(I1,1)
      KNDR(2)=KNEL(I1,2)
      KNDR(3)=KNEL(E(1),S1)
      END IF
C
C      Knotennummern des 2.Dreiecks
C
      IF (KNEL(I1,1).EQ.KNEL(E(3),1)) S3=2
      IF (KNEL(I1,1).EQ.KNEL(E(3),2)) S3=1
      IF (KNEL(E(3),S3).LT.KNEL(I1,1)) THEN
      KNDR(4)=KNEL(E(3),S3)
      KNDR(5)=KNEL(I1,1)
      KNDR(6)=KNEL(I1,2)
      ELSE IF (KNEL(E(3),S3).LT.KNEL(I1,2)) THEN
      KNDR(4)=KNEL(I1,1)
      KNDR(5)=KNEL(E(3),S3)
      KNDR(6)=KNEL(I1,2)
      ELSE
      KNDR(4)=KNEL(I1,1)
      KNDR(5)=KNEL(I1,2)
      KNDR(6)=KNEL(E(3),S3)
      END IF
      IF (PLA.EQ.'v') GOTO 7301
      H1=H
      H2=H
      IF (PLA.EQ.'k') GOTO 7350
C
C      Ermittlung des Index ID1 des 1.Dreiecks.
C      ID wird nur dann um 1 erhoeht, wenn das Dreieck mit denselben
C      Knoten nicht schon vorher vorgekommen ist.
C
7301  KONTR1=0
      IF (ID.EQ.0) GOTO 7320
      DO 7315 J=1,ID
      IF (KN1(J).EQ.KNDR(1).AND.KN2(J).EQ.KNDR(2).AND.KN3(J).EQ.KNDR(3))
     * THEN
      KONTR1=1
      ID1=J
      GOTO 7302
      ELSE
      GOTO 7315
      END IF
7315  CONTINUE
7320  IF (KONTR1.EQ.0) ID = ID + 1
      KN1(ID)=KNDR(1)
      KN2(ID)=KNDR(2)
      KN3(ID)=KNDR(3)
      ID1=ID
C
C      Ermittlung des Index ID2 des 2.Dreiecks.
C      ID wird nur dann um 1 erhoeht, wenn das Dreieck mit denselben
C      Knoten nicht schon vorher vorgekommen ist.
C
7302  KONTR2=0
      IF (ID.EQ.0) GOTO 7340
      DO 7330 J=1,ID
      IF (KN1(J).EQ.KNDR(4).AND.KN2(J).EQ.KNDR(5).AND.KN3(J).EQ.KNDR(6))
     * THEN
      KONTR2=1
      ID2=J
      GOTO 7303
      ELSE
      GOTO 7330
      END IF
7330  CONTINUE
7340  IF (KONTR2.EQ.0) ID = ID + 1
      KN1(ID)=KNDR(4)
      KN2(ID)=KNDR(5)
      KN3(ID)=KNDR(6)
      ID2=ID
C
C      Lesen der Dreiecksdicke aus der Datei "DREIECK", 1.Dreieck
C
7303  IF (DIK.EQ.'e') GOTO 7304
      IF (KONTR1.EQ.1) THEN
      H1=DI(ID1)
      GOTO 7304
      ELSE
      READ (10,720) ID1,DI(ID1)
      H1=DI(ID1)
      GOTO 7304
      END IF
C
C      Eingabe der variablen Plattendicke, erstes Dreieck
C
7304  IF (KON.EQ.'o'.AND.DIK.EQ.'d') GOTO 7307
      WRITE (3,731) ID1,KN1(ID1),KN2(ID1),KN3(ID1)
731   FORMAT (' Die Knoten des 1.Dreiecks Nr.',I4,' sind: ',3(1X,I4))
      IF (DIK.EQ.'d') GOTO 7305
      IF (AUS.EQ.'b') GOTO 7325
      WRITE (1,721) ID1,KN1(ID1),KN2(ID1),KN3(ID1)
7325  IF (KONTR1.EQ.1) GOTO 7305
      WRITE (1,732) H1
732   FORMAT (' Dicke des 1.Dreiecks (',F10.3,'):')
      READ (1,723) DI(ID1)
      IF (DI(ID1).EQ.0.) DI(ID1)=H1
7305  H1=DI(ID1)
      WRITE (3,724) H1
      IF (DIK.EQ.'d') GOTO 7307
      IF (AUS.EQ.'b') GOTO 7306
      WRITE (1,724) H1
7306  IF (KONTR1.EQ.1) GOTO 7307
      WRITE (10,725) ID1,DI(ID1),KN1(ID1),KN2(ID1),KN3(ID1)
C
C      Lesen der Dreiecksdicke aus der Datei "DREIECK", 2.Dreieck
C
7307  IF (DIK.EQ.'e') GOTO 7308
      IF (KONTR2.EQ.1) THEN
      H2=DI(ID2)
      GOTO 7308
      ELSE
      READ (10,720) ID2,DI(ID2)
      H2=DI(ID2)
      GOTO 7308
      END IF
C
C      Eingabe der variablen Plattendicke, zweites Dreieck
C
7308  IF (KON.EQ.'o'.AND.DIK.EQ.'d') GOTO 7350
      WRITE (3,733) ID2,KN1(ID2),KN2(ID2),KN3(ID2)
733   FORMAT (' Die Knoten des 2.Dreiecks Nr.',I4,' sind: ',3(1X,I4))
      IF (DIK.EQ.'d') GOTO 7309
      IF (AUS.EQ.'b') GOTO 7335
      WRITE (1,721) ID2,KN1(ID2),KN2(ID2),KN3(ID2)
7335  IF (KONTR2.EQ.1) GOTO 7309
      WRITE (1,734) H2
734   FORMAT (' Dicke des 2.Dreiecks (',F10.3,'):')
      READ (1,723) DI(ID2)
      IF (DI(ID2).EQ.0.) DI(ID2)=H2
7309  H2=DI(ID2)
      WRITE (3,724) H2
      IF (DIK.EQ.'d') GOTO 7350
      IF (AUS.EQ.'b') GOTO 7310
      WRITE (1,724) H2
7310  IF (KONTR2.EQ.1) GOTO 7350
      WRITE (10,725) ID2,DI(ID2),KN1(ID2),KN2(ID2),KN3(ID2)
C
C      Flaechen der Dreiecke
C
7350  F1=0.5*ABS ( X(KNDR(1)) * ( Y(KNDR(2)) - Y(KNDR(3)) )
     *           + X(KNDR(2)) * ( Y(KNDR(3)) - Y(KNDR(1)) )
     *           + X(KNDR(3)) * ( Y(KNDR(1)) - Y(KNDR(2)) ) )
      F2=0.5*ABS ( X(KNDR(4)) * ( Y(KNDR(5)) - Y(KNDR(6)) )
     *           + X(KNDR(5)) * ( Y(KNDR(6)) - Y(KNDR(4)) )
     *           + X(KNDR(6)) * ( Y(KNDR(4)) - Y(KNDR(5)) ) )
C
C      Berechnung der Stablaengen mit:
C
C      L(1)=L(I1); L(2)=L(E(1)); L(3)=L(E(2));
C                  L(4)=L(E(3)); L(5)=L(E(4))
C
      L(1)=SQRT ( ( X(KNEL(I1,2)) - X(KNEL(I1,1)) )**2
     *           +( Y(KNEL(I1,2)) - Y(KNEL(I1,1)) )**2 )
      L(2)=SQRT ( ( X(KNEL(E(1),2)) - X(KNEL(E(1),1)) )**2
     *           +( Y(KNEL(E(1),2)) - Y(KNEL(E(1),1)) )**2 )    
      L(3)=SQRT ( ( X(KNEL(E(2),2)) - X(KNEL(E(2),1)) )**2
     *           +( Y(KNEL(E(2),2)) - Y(KNEL(E(2),1)) )**2 )    
      L(4)=SQRT ( ( X(KNEL(E(3),2)) - X(KNEL(E(3),1)) )**2
     *           +( Y(KNEL(E(3),2)) - Y(KNEL(E(3),1)) )**2 )    
      L(5)=SQRT ( ( X(KNEL(E(4),2)) - X(KNEL(E(4),1)) )**2
     *           +( Y(KNEL(E(4),2)) - Y(KNEL(E(4),1)) )**2 )    
C
C      Querschnittsflaeche des Stabes
C
      IF (DIV.EQ.'l') GOTO 7360
      A(I1) = FAK * ( H1 * F1 /( L(1) + L(2) + L(3) )
     *              + H2 * F2 /( L(1) + L(4) + L(5) ) )
      GOTO 7370
7360  A(I1) = FAK * ( H1 * F1 + H2 * F2 ) / L(1)
C
C      Kontrollausgaben
C
7370  IF (KON.EQ.'o') GOTO 7800
      WRITE (3,76) I1,A(I1)
      WRITE (3,77) I1,L(1)
      IF (PLA.EQ.'k'.OR.DIK.EQ.'d'.OR.DIK.EQ.'e'.AND.AUS.EQ.'b')
     * GOTO 7800
      WRITE (1,76) I1,A(I1)
      WRITE (1,77) I1,L(1)
C
C     ***********************************************************
C     * Abspeichern der kleinsten und der groessten Stabflaeche.*
C     * Im  Falle  eines  Pendelstabes, bei dem VAR='h' gesetzt *
C     * wurde, wird diese Rechnung uebersprungen.               *
C     ***********************************************************
C
7800  IF (N.EQ.0.AND.VAR.EQ.'h') GOTO 7900
      IF (I1.GT.1) GOTO 7810
      AGR=A(1)
      AKL=A(1)
7810  IF (A(I1).GE.AGR) AGR=A(I1)
      IF (A(I1).LE.AKL) AKL=A(I1)
C
C     ***************************************
C     * Ende der Schleife ueber alle Staebe *
C     ***************************************
C
7900  CONTINUE
C
C     ***********************************************
C     *   Zuordnung der Stabflaechen zu Referenz-   *
C     *   nummern und Berechnung der Mittelwerte    *
C     *          fuer jede Referenzklasse           *
C     ***********************************************
C
      PRINT*
      WRITE (1,'(1H ,''Berechnen der Referenzen'')')
C
C      Ermitteln des Toleranzfaktors fuer jede Referenzklasse
C
      IF (PEND.EQ.0) HREF=ANZREF
      TOL=(AGR/AKL)**(1./HREF)
      IF (KON.EQ.'o') GOTO 8100
      WRITE (3,61)
      WRITE (3,80) AGR
80    FORMAT (' Groesste Flaeche:',F12.3)
      WRITE (3,81) AKL
81    FORMAT (' Kleinste Flaeche:',F12.3)
      WRITE (3,82) TOL
82    FORMAT (1H ,'Der Toleranzfaktor einer Referenznummer ist: ',F7.3)
      WRITE (3,83) ANZREF,HREF
83    FORMAT (1H ,'Ref.-Zahl: ',I2,'  hoechste Ref.: ',I2)
      WRITE (3,61)
C    
C      Zuordnung der Referenzklassen zu den Staeben
C
8100  DO 8500 I=1,HREF
      IF (I.EQ.1) THEN
      AGRENZ=AKL
      ELSE
      AGRENZ=AGRENZ*TOL
      END IF
      DO 8200 I1=1,EGRNR
      IF (A(I1).GE.AGRENZ.AND.A(I1).LT.AGRENZ*TOL) REF(I1)=I
      IF (A(I1).EQ.AGR) REF(I1)=HREF
8200  CONTINUE
C
C      Berechnen der mittleren Stabflaeche fuer jede Referenzklasse
C
      ARK(I)=0
      J=0
      DO 8300 I1=1,EGRNR
      IF (REF(I1).NE.I) GOTO 8300
      ARK(I)=ARK(I)+A(I1)
      J=J+1
8300  CONTINUE
      IF (J.EQ.0) GOTO 8400
      ARK(I)=ARK(I)/J
C
C      Kontrollausgaben
C
8400  IF (KON.EQ.'o') GOTO 8500
      WRITE (3,85) I,ARK(I)
85    FORMAT (' Ref.-NR: ',I2,'  Flaeche: ',F12.3)
      WRITE (3,86) J
86    FORMAT (' Anzahl der Staebe: ',I4)
8500  CONTINUE
      IF (KON.EQ.'o') GOTO 9000
      IF (VAR.EQ.'b'.OR.PEND.EQ.0) GOTO 9000
      WRITE (3,87) ANZREF,ARK(ANZREF)
87    FORMAT (' Ref.-NR: ',I2,'  Flaeche: ',F12.3)
      WRITE (3,86) PEND
C
C     ********************************************
C     * Einschreiben der berechneten Referenzen  *
C     *           in die Strukturdatei           *
C     ********************************************
C
9000  PRINT*
      WRITE (1,'(1H ,''Ergaenzen der Strukturdatei'')')
C
C      Suche nach dem Datenblock ELEM
C
      REWIND 50
9100  READ (50,90) TEXT
90    FORMAT (A4)
      IF (TEXT.EQ.ELEM) GOTO 9200
      GOTO 9100
C
C      Neuerstellen des Datenblockes ELEM
C
9200  KNANZ=2
      DO 9300 I1=1,EGRNR-1
      WRITE (50,91) I1,REF(I1),KNANZ,(KNEL(I1,M),M=1,2)
91    FORMAT (1X,I4,4I5)
9300  CONTINUE
      WRITE (50,92)STERN,EGRNR,REF(EGRNR),KNANZ,(KNEL(EGRNR,M),M=1,2)
92    FORMAT (A1,I4,4I5)
C
C      Suche nach dem Dateiende
C
9400  READ (50,90) TEXT
      IF (TEXT.EQ.ENDE) GOTO 9500
      GOTO 9400
C     
C      Erstellen des Datenblocks REFE
C
9500  WRITE (50,90) REFE
      ELART=4.
      EMOD=210000.
      DO 9600 I=1,ANZREF-1
      WRITE (50,95) I,ELART,EMOD,ARK(I)
95    FORMAT (1X,I4,5X,3F10.0)
9600  CONTINUE
      WRITE (50,96) STERN,ANZREF,ELART,EMOD,ARK(ANZREF)
96    FORMAT (A1,I4,5X,3F10.0)
      STOP
      END
